// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from kompass_interfaces:action/ControlPath.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__ACTION__DETAIL__CONTROL_PATH__STRUCT_H_
#define KOMPASS_INTERFACES__ACTION__DETAIL__CONTROL_PATH__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'path_name'
// Member 'path_file_location'
#include "rosidl_runtime_c/string.h"

/// Struct defined in action/ControlPath in the package kompass_interfaces.
typedef struct kompass_interfaces__action__ControlPath_Goal
{
  int32_t path_source;
  /// ROS topic name or path file url
  rosidl_runtime_c__String path_name;
  /// path file location
  rosidl_runtime_c__String path_file_location;
  /// select a controller
  int32_t controller;
} kompass_interfaces__action__ControlPath_Goal;

// Struct for a sequence of kompass_interfaces__action__ControlPath_Goal.
typedef struct kompass_interfaces__action__ControlPath_Goal__Sequence
{
  kompass_interfaces__action__ControlPath_Goal * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__ControlPath_Goal__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'destination_error'
#include "kompass_interfaces/msg/detail/path_tracking_error__struct.h"

/// Struct defined in action/ControlPath in the package kompass_interfaces.
typedef struct kompass_interfaces__action__ControlPath_Result
{
  kompass_interfaces__msg__PathTrackingError destination_error;
} kompass_interfaces__action__ControlPath_Result;

// Struct for a sequence of kompass_interfaces__action__ControlPath_Result.
typedef struct kompass_interfaces__action__ControlPath_Result__Sequence
{
  kompass_interfaces__action__ControlPath_Result * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__ControlPath_Result__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'global_path_deviation'
// already included above
// #include "kompass_interfaces/msg/detail/path_tracking_error__struct.h"
// Member 'control'
#include "geometry_msgs/msg/detail/twist__struct.h"
// Member 'control_list'
#include "kompass_interfaces/msg/detail/twist_array__struct.h"

/// Struct defined in action/ControlPath in the package kompass_interfaces.
typedef struct kompass_interfaces__action__ControlPath_Feedback
{
  kompass_interfaces__msg__PathTrackingError global_path_deviation;
  double prediction_horizon;
  double compute_time;
  geometry_msgs__msg__Twist control;
  kompass_interfaces__msg__TwistArray control_list;
} kompass_interfaces__action__ControlPath_Feedback;

// Struct for a sequence of kompass_interfaces__action__ControlPath_Feedback.
typedef struct kompass_interfaces__action__ControlPath_Feedback__Sequence
{
  kompass_interfaces__action__ControlPath_Feedback * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__ControlPath_Feedback__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__struct.h"
// Member 'goal'
#include "kompass_interfaces/action/detail/control_path__struct.h"

/// Struct defined in action/ControlPath in the package kompass_interfaces.
typedef struct kompass_interfaces__action__ControlPath_SendGoal_Request
{
  unique_identifier_msgs__msg__UUID goal_id;
  kompass_interfaces__action__ControlPath_Goal goal;
} kompass_interfaces__action__ControlPath_SendGoal_Request;

// Struct for a sequence of kompass_interfaces__action__ControlPath_SendGoal_Request.
typedef struct kompass_interfaces__action__ControlPath_SendGoal_Request__Sequence
{
  kompass_interfaces__action__ControlPath_SendGoal_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__ControlPath_SendGoal_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.h"

/// Struct defined in action/ControlPath in the package kompass_interfaces.
typedef struct kompass_interfaces__action__ControlPath_SendGoal_Response
{
  bool accepted;
  builtin_interfaces__msg__Time stamp;
} kompass_interfaces__action__ControlPath_SendGoal_Response;

// Struct for a sequence of kompass_interfaces__action__ControlPath_SendGoal_Response.
typedef struct kompass_interfaces__action__ControlPath_SendGoal_Response__Sequence
{
  kompass_interfaces__action__ControlPath_SendGoal_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__ControlPath_SendGoal_Response__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.h"

/// Struct defined in action/ControlPath in the package kompass_interfaces.
typedef struct kompass_interfaces__action__ControlPath_GetResult_Request
{
  unique_identifier_msgs__msg__UUID goal_id;
} kompass_interfaces__action__ControlPath_GetResult_Request;

// Struct for a sequence of kompass_interfaces__action__ControlPath_GetResult_Request.
typedef struct kompass_interfaces__action__ControlPath_GetResult_Request__Sequence
{
  kompass_interfaces__action__ControlPath_GetResult_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__ControlPath_GetResult_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'result'
// already included above
// #include "kompass_interfaces/action/detail/control_path__struct.h"

/// Struct defined in action/ControlPath in the package kompass_interfaces.
typedef struct kompass_interfaces__action__ControlPath_GetResult_Response
{
  int8_t status;
  kompass_interfaces__action__ControlPath_Result result;
} kompass_interfaces__action__ControlPath_GetResult_Response;

// Struct for a sequence of kompass_interfaces__action__ControlPath_GetResult_Response.
typedef struct kompass_interfaces__action__ControlPath_GetResult_Response__Sequence
{
  kompass_interfaces__action__ControlPath_GetResult_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__ControlPath_GetResult_Response__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.h"
// Member 'feedback'
// already included above
// #include "kompass_interfaces/action/detail/control_path__struct.h"

/// Struct defined in action/ControlPath in the package kompass_interfaces.
typedef struct kompass_interfaces__action__ControlPath_FeedbackMessage
{
  unique_identifier_msgs__msg__UUID goal_id;
  kompass_interfaces__action__ControlPath_Feedback feedback;
} kompass_interfaces__action__ControlPath_FeedbackMessage;

// Struct for a sequence of kompass_interfaces__action__ControlPath_FeedbackMessage.
typedef struct kompass_interfaces__action__ControlPath_FeedbackMessage__Sequence
{
  kompass_interfaces__action__ControlPath_FeedbackMessage * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__ControlPath_FeedbackMessage__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // KOMPASS_INTERFACES__ACTION__DETAIL__CONTROL_PATH__STRUCT_H_
