// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from kompass_interfaces:action/FollowPath.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__ACTION__DETAIL__FOLLOW_PATH__STRUCT_H_
#define KOMPASS_INTERFACES__ACTION__DETAIL__FOLLOW_PATH__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'request'
#include "kompass_interfaces/msg/detail/follow_path_request__struct.h"

/// Struct defined in action/FollowPath in the package kompass_interfaces.
typedef struct kompass_interfaces__action__FollowPath_Goal
{
  kompass_interfaces__msg__FollowPathRequest request;
} kompass_interfaces__action__FollowPath_Goal;

// Struct for a sequence of kompass_interfaces__action__FollowPath_Goal.
typedef struct kompass_interfaces__action__FollowPath_Goal__Sequence
{
  kompass_interfaces__action__FollowPath_Goal * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__FollowPath_Goal__Sequence;


// Constants defined in the message

/// Struct defined in action/FollowPath in the package kompass_interfaces.
typedef struct kompass_interfaces__action__FollowPath_Result
{
  bool reached_end;
} kompass_interfaces__action__FollowPath_Result;

// Struct for a sequence of kompass_interfaces__action__FollowPath_Result.
typedef struct kompass_interfaces__action__FollowPath_Result__Sequence
{
  kompass_interfaces__action__FollowPath_Result * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__FollowPath_Result__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'tracking_error'
#include "kompass_interfaces/msg/detail/path_tracking_error__struct.h"

/// Struct defined in action/FollowPath in the package kompass_interfaces.
typedef struct kompass_interfaces__action__FollowPath_Feedback
{
  kompass_interfaces__msg__PathTrackingError tracking_error;
} kompass_interfaces__action__FollowPath_Feedback;

// Struct for a sequence of kompass_interfaces__action__FollowPath_Feedback.
typedef struct kompass_interfaces__action__FollowPath_Feedback__Sequence
{
  kompass_interfaces__action__FollowPath_Feedback * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__FollowPath_Feedback__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__struct.h"
// Member 'goal'
#include "kompass_interfaces/action/detail/follow_path__struct.h"

/// Struct defined in action/FollowPath in the package kompass_interfaces.
typedef struct kompass_interfaces__action__FollowPath_SendGoal_Request
{
  unique_identifier_msgs__msg__UUID goal_id;
  kompass_interfaces__action__FollowPath_Goal goal;
} kompass_interfaces__action__FollowPath_SendGoal_Request;

// Struct for a sequence of kompass_interfaces__action__FollowPath_SendGoal_Request.
typedef struct kompass_interfaces__action__FollowPath_SendGoal_Request__Sequence
{
  kompass_interfaces__action__FollowPath_SendGoal_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__FollowPath_SendGoal_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.h"

/// Struct defined in action/FollowPath in the package kompass_interfaces.
typedef struct kompass_interfaces__action__FollowPath_SendGoal_Response
{
  bool accepted;
  builtin_interfaces__msg__Time stamp;
} kompass_interfaces__action__FollowPath_SendGoal_Response;

// Struct for a sequence of kompass_interfaces__action__FollowPath_SendGoal_Response.
typedef struct kompass_interfaces__action__FollowPath_SendGoal_Response__Sequence
{
  kompass_interfaces__action__FollowPath_SendGoal_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__FollowPath_SendGoal_Response__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.h"

/// Struct defined in action/FollowPath in the package kompass_interfaces.
typedef struct kompass_interfaces__action__FollowPath_GetResult_Request
{
  unique_identifier_msgs__msg__UUID goal_id;
} kompass_interfaces__action__FollowPath_GetResult_Request;

// Struct for a sequence of kompass_interfaces__action__FollowPath_GetResult_Request.
typedef struct kompass_interfaces__action__FollowPath_GetResult_Request__Sequence
{
  kompass_interfaces__action__FollowPath_GetResult_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__FollowPath_GetResult_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'result'
// already included above
// #include "kompass_interfaces/action/detail/follow_path__struct.h"

/// Struct defined in action/FollowPath in the package kompass_interfaces.
typedef struct kompass_interfaces__action__FollowPath_GetResult_Response
{
  int8_t status;
  kompass_interfaces__action__FollowPath_Result result;
} kompass_interfaces__action__FollowPath_GetResult_Response;

// Struct for a sequence of kompass_interfaces__action__FollowPath_GetResult_Response.
typedef struct kompass_interfaces__action__FollowPath_GetResult_Response__Sequence
{
  kompass_interfaces__action__FollowPath_GetResult_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__FollowPath_GetResult_Response__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.h"
// Member 'feedback'
// already included above
// #include "kompass_interfaces/action/detail/follow_path__struct.h"

/// Struct defined in action/FollowPath in the package kompass_interfaces.
typedef struct kompass_interfaces__action__FollowPath_FeedbackMessage
{
  unique_identifier_msgs__msg__UUID goal_id;
  kompass_interfaces__action__FollowPath_Feedback feedback;
} kompass_interfaces__action__FollowPath_FeedbackMessage;

// Struct for a sequence of kompass_interfaces__action__FollowPath_FeedbackMessage.
typedef struct kompass_interfaces__action__FollowPath_FeedbackMessage__Sequence
{
  kompass_interfaces__action__FollowPath_FeedbackMessage * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__FollowPath_FeedbackMessage__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // KOMPASS_INTERFACES__ACTION__DETAIL__FOLLOW_PATH__STRUCT_H_
