// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from kompass_interfaces:msg/FollowPathRequest.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__MSG__DETAIL__FOLLOW_PATH_REQUEST__STRUCT_HPP_
#define KOMPASS_INTERFACES__MSG__DETAIL__FOLLOW_PATH_REQUEST__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__msg__FollowPathRequest __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__msg__FollowPathRequest __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct FollowPathRequest_
{
  using Type = FollowPathRequest_<ContainerAllocator>;

  explicit FollowPathRequest_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->path_source = 0l;
      this->path_name = "";
      this->path_file_location = "";
      this->path_follower_type = 0l;
      this->robot_cmd_topic = "";
    }
  }

  explicit FollowPathRequest_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : path_name(_alloc),
    path_file_location(_alloc),
    robot_cmd_topic(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->path_source = 0l;
      this->path_name = "";
      this->path_file_location = "";
      this->path_follower_type = 0l;
      this->robot_cmd_topic = "";
    }
  }

  // field types and members
  using _path_source_type =
    int32_t;
  _path_source_type path_source;
  using _path_name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _path_name_type path_name;
  using _path_file_location_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _path_file_location_type path_file_location;
  using _path_follower_type_type =
    int32_t;
  _path_follower_type_type path_follower_type;
  using _robot_cmd_topic_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _robot_cmd_topic_type robot_cmd_topic;

  // setters for named parameter idiom
  Type & set__path_source(
    const int32_t & _arg)
  {
    this->path_source = _arg;
    return *this;
  }
  Type & set__path_name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->path_name = _arg;
    return *this;
  }
  Type & set__path_file_location(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->path_file_location = _arg;
    return *this;
  }
  Type & set__path_follower_type(
    const int32_t & _arg)
  {
    this->path_follower_type = _arg;
    return *this;
  }
  Type & set__robot_cmd_topic(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->robot_cmd_topic = _arg;
    return *this;
  }

  // constant declarations
  static constexpr int32_t FOLLOW_PATH_FROM_ROS_TOPIC =
    0;
  static constexpr int32_t FOLLOW_PATH_FROM_XML_FILE =
    1;

  // pointer types
  using RawPtr =
    kompass_interfaces::msg::FollowPathRequest_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::msg::FollowPathRequest_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::msg::FollowPathRequest_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::msg::FollowPathRequest_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::msg::FollowPathRequest_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::msg::FollowPathRequest_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::msg::FollowPathRequest_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::msg::FollowPathRequest_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::msg::FollowPathRequest_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::msg::FollowPathRequest_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__msg__FollowPathRequest
    std::shared_ptr<kompass_interfaces::msg::FollowPathRequest_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__msg__FollowPathRequest
    std::shared_ptr<kompass_interfaces::msg::FollowPathRequest_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const FollowPathRequest_ & other) const
  {
    if (this->path_source != other.path_source) {
      return false;
    }
    if (this->path_name != other.path_name) {
      return false;
    }
    if (this->path_file_location != other.path_file_location) {
      return false;
    }
    if (this->path_follower_type != other.path_follower_type) {
      return false;
    }
    if (this->robot_cmd_topic != other.robot_cmd_topic) {
      return false;
    }
    return true;
  }
  bool operator!=(const FollowPathRequest_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct FollowPathRequest_

// alias to use template instance with default allocator
using FollowPathRequest =
  kompass_interfaces::msg::FollowPathRequest_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t FollowPathRequest_<ContainerAllocator>::FOLLOW_PATH_FROM_ROS_TOPIC;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t FollowPathRequest_<ContainerAllocator>::FOLLOW_PATH_FROM_XML_FILE;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace kompass_interfaces

#endif  // KOMPASS_INTERFACES__MSG__DETAIL__FOLLOW_PATH_REQUEST__STRUCT_HPP_
