// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from kompass_interfaces:msg/FollowPathRequest.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__MSG__DETAIL__FOLLOW_PATH_REQUEST__TRAITS_HPP_
#define KOMPASS_INTERFACES__MSG__DETAIL__FOLLOW_PATH_REQUEST__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "kompass_interfaces/msg/detail/follow_path_request__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace kompass_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const FollowPathRequest & msg,
  std::ostream & out)
{
  out << "{";
  // member: path_source
  {
    out << "path_source: ";
    rosidl_generator_traits::value_to_yaml(msg.path_source, out);
    out << ", ";
  }

  // member: path_name
  {
    out << "path_name: ";
    rosidl_generator_traits::value_to_yaml(msg.path_name, out);
    out << ", ";
  }

  // member: path_file_location
  {
    out << "path_file_location: ";
    rosidl_generator_traits::value_to_yaml(msg.path_file_location, out);
    out << ", ";
  }

  // member: path_follower_type
  {
    out << "path_follower_type: ";
    rosidl_generator_traits::value_to_yaml(msg.path_follower_type, out);
    out << ", ";
  }

  // member: robot_cmd_topic
  {
    out << "robot_cmd_topic: ";
    rosidl_generator_traits::value_to_yaml(msg.robot_cmd_topic, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const FollowPathRequest & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: path_source
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "path_source: ";
    rosidl_generator_traits::value_to_yaml(msg.path_source, out);
    out << "\n";
  }

  // member: path_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "path_name: ";
    rosidl_generator_traits::value_to_yaml(msg.path_name, out);
    out << "\n";
  }

  // member: path_file_location
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "path_file_location: ";
    rosidl_generator_traits::value_to_yaml(msg.path_file_location, out);
    out << "\n";
  }

  // member: path_follower_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "path_follower_type: ";
    rosidl_generator_traits::value_to_yaml(msg.path_follower_type, out);
    out << "\n";
  }

  // member: robot_cmd_topic
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "robot_cmd_topic: ";
    rosidl_generator_traits::value_to_yaml(msg.robot_cmd_topic, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const FollowPathRequest & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use kompass_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const kompass_interfaces::msg::FollowPathRequest & msg,
  std::ostream & out, size_t indentation = 0)
{
  kompass_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use kompass_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const kompass_interfaces::msg::FollowPathRequest & msg)
{
  return kompass_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<kompass_interfaces::msg::FollowPathRequest>()
{
  return "kompass_interfaces::msg::FollowPathRequest";
}

template<>
inline const char * name<kompass_interfaces::msg::FollowPathRequest>()
{
  return "kompass_interfaces/msg/FollowPathRequest";
}

template<>
struct has_fixed_size<kompass_interfaces::msg::FollowPathRequest>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<kompass_interfaces::msg::FollowPathRequest>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<kompass_interfaces::msg::FollowPathRequest>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // KOMPASS_INTERFACES__MSG__DETAIL__FOLLOW_PATH_REQUEST__TRAITS_HPP_
