// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from kompass_interfaces:msg/Obstacles.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__MSG__DETAIL__OBSTACLES__TRAITS_HPP_
#define KOMPASS_INTERFACES__MSG__DETAIL__OBSTACLES__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "kompass_interfaces/msg/detail/obstacles__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'info'
#include "nav_msgs/msg/detail/map_meta_data__traits.hpp"

namespace kompass_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const Obstacles & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: info
  {
    out << "info: ";
    to_flow_style_yaml(msg.info, out);
    out << ", ";
  }

  // member: obstacle_type
  {
    if (msg.obstacle_type.size() == 0) {
      out << "obstacle_type: []";
    } else {
      out << "obstacle_type: [";
      size_t pending_items = msg.obstacle_type.size();
      for (auto item : msg.obstacle_type) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: x_global
  {
    if (msg.x_global.size() == 0) {
      out << "x_global: []";
    } else {
      out << "x_global: [";
      size_t pending_items = msg.x_global.size();
      for (auto item : msg.x_global) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: y_global
  {
    if (msg.y_global.size() == 0) {
      out << "y_global: []";
    } else {
      out << "y_global: [";
      size_t pending_items = msg.y_global.size();
      for (auto item : msg.y_global) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: x_local
  {
    if (msg.x_local.size() == 0) {
      out << "x_local: []";
    } else {
      out << "x_local: [";
      size_t pending_items = msg.x_local.size();
      for (auto item : msg.x_local) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: y_local
  {
    if (msg.y_local.size() == 0) {
      out << "y_local: []";
    } else {
      out << "y_local: [";
      size_t pending_items = msg.y_local.size();
      for (auto item : msg.y_local) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: i_grid
  {
    if (msg.i_grid.size() == 0) {
      out << "i_grid: []";
    } else {
      out << "i_grid: [";
      size_t pending_items = msg.i_grid.size();
      for (auto item : msg.i_grid) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: j_grid
  {
    if (msg.j_grid.size() == 0) {
      out << "j_grid: []";
    } else {
      out << "j_grid: [";
      size_t pending_items = msg.j_grid.size();
      for (auto item : msg.j_grid) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: occupied_zone
  {
    if (msg.occupied_zone.size() == 0) {
      out << "occupied_zone: []";
    } else {
      out << "occupied_zone: [";
      size_t pending_items = msg.occupied_zone.size();
      for (auto item : msg.occupied_zone) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: class_id
  {
    if (msg.class_id.size() == 0) {
      out << "class_id: []";
    } else {
      out << "class_id: [";
      size_t pending_items = msg.class_id.size();
      for (auto item : msg.class_id) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: object_id
  {
    if (msg.object_id.size() == 0) {
      out << "object_id: []";
    } else {
      out << "object_id: [";
      size_t pending_items = msg.object_id.size();
      for (auto item : msg.object_id) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: vx
  {
    if (msg.vx.size() == 0) {
      out << "vx: []";
    } else {
      out << "vx: [";
      size_t pending_items = msg.vx.size();
      for (auto item : msg.vx) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: vy
  {
    if (msg.vy.size() == 0) {
      out << "vy: []";
    } else {
      out << "vy: [";
      size_t pending_items = msg.vy.size();
      for (auto item : msg.vy) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Obstacles & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "info:\n";
    to_block_style_yaml(msg.info, out, indentation + 2);
  }

  // member: obstacle_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.obstacle_type.size() == 0) {
      out << "obstacle_type: []\n";
    } else {
      out << "obstacle_type:\n";
      for (auto item : msg.obstacle_type) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: x_global
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.x_global.size() == 0) {
      out << "x_global: []\n";
    } else {
      out << "x_global:\n";
      for (auto item : msg.x_global) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: y_global
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.y_global.size() == 0) {
      out << "y_global: []\n";
    } else {
      out << "y_global:\n";
      for (auto item : msg.y_global) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: x_local
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.x_local.size() == 0) {
      out << "x_local: []\n";
    } else {
      out << "x_local:\n";
      for (auto item : msg.x_local) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: y_local
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.y_local.size() == 0) {
      out << "y_local: []\n";
    } else {
      out << "y_local:\n";
      for (auto item : msg.y_local) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: i_grid
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.i_grid.size() == 0) {
      out << "i_grid: []\n";
    } else {
      out << "i_grid:\n";
      for (auto item : msg.i_grid) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: j_grid
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.j_grid.size() == 0) {
      out << "j_grid: []\n";
    } else {
      out << "j_grid:\n";
      for (auto item : msg.j_grid) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: occupied_zone
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.occupied_zone.size() == 0) {
      out << "occupied_zone: []\n";
    } else {
      out << "occupied_zone:\n";
      for (auto item : msg.occupied_zone) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: class_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.class_id.size() == 0) {
      out << "class_id: []\n";
    } else {
      out << "class_id:\n";
      for (auto item : msg.class_id) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: object_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.object_id.size() == 0) {
      out << "object_id: []\n";
    } else {
      out << "object_id:\n";
      for (auto item : msg.object_id) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: vx
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.vx.size() == 0) {
      out << "vx: []\n";
    } else {
      out << "vx:\n";
      for (auto item : msg.vx) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: vy
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.vy.size() == 0) {
      out << "vy: []\n";
    } else {
      out << "vy:\n";
      for (auto item : msg.vy) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Obstacles & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use kompass_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const kompass_interfaces::msg::Obstacles & msg,
  std::ostream & out, size_t indentation = 0)
{
  kompass_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use kompass_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const kompass_interfaces::msg::Obstacles & msg)
{
  return kompass_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<kompass_interfaces::msg::Obstacles>()
{
  return "kompass_interfaces::msg::Obstacles";
}

template<>
inline const char * name<kompass_interfaces::msg::Obstacles>()
{
  return "kompass_interfaces/msg/Obstacles";
}

template<>
struct has_fixed_size<kompass_interfaces::msg::Obstacles>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<kompass_interfaces::msg::Obstacles>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<kompass_interfaces::msg::Obstacles>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // KOMPASS_INTERFACES__MSG__DETAIL__OBSTACLES__TRAITS_HPP_
