// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from kompass_interfaces:msg/PathTrackingError.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__MSG__DETAIL__PATH_TRACKING_ERROR__FUNCTIONS_H_
#define KOMPASS_INTERFACES__MSG__DETAIL__PATH_TRACKING_ERROR__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "kompass_interfaces/msg/rosidl_generator_c__visibility_control.h"

#include "kompass_interfaces/msg/detail/path_tracking_error__struct.h"

/// Initialize msg/PathTrackingError message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * kompass_interfaces__msg__PathTrackingError
 * )) before or use
 * kompass_interfaces__msg__PathTrackingError__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_kompass_interfaces
bool
kompass_interfaces__msg__PathTrackingError__init(kompass_interfaces__msg__PathTrackingError * msg);

/// Finalize msg/PathTrackingError message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_kompass_interfaces
void
kompass_interfaces__msg__PathTrackingError__fini(kompass_interfaces__msg__PathTrackingError * msg);

/// Create msg/PathTrackingError message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * kompass_interfaces__msg__PathTrackingError__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_kompass_interfaces
kompass_interfaces__msg__PathTrackingError *
kompass_interfaces__msg__PathTrackingError__create();

/// Destroy msg/PathTrackingError message.
/**
 * It calls
 * kompass_interfaces__msg__PathTrackingError__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_kompass_interfaces
void
kompass_interfaces__msg__PathTrackingError__destroy(kompass_interfaces__msg__PathTrackingError * msg);

/// Check for msg/PathTrackingError message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_kompass_interfaces
bool
kompass_interfaces__msg__PathTrackingError__are_equal(const kompass_interfaces__msg__PathTrackingError * lhs, const kompass_interfaces__msg__PathTrackingError * rhs);

/// Copy a msg/PathTrackingError message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_kompass_interfaces
bool
kompass_interfaces__msg__PathTrackingError__copy(
  const kompass_interfaces__msg__PathTrackingError * input,
  kompass_interfaces__msg__PathTrackingError * output);

/// Initialize array of msg/PathTrackingError messages.
/**
 * It allocates the memory for the number of elements and calls
 * kompass_interfaces__msg__PathTrackingError__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_kompass_interfaces
bool
kompass_interfaces__msg__PathTrackingError__Sequence__init(kompass_interfaces__msg__PathTrackingError__Sequence * array, size_t size);

/// Finalize array of msg/PathTrackingError messages.
/**
 * It calls
 * kompass_interfaces__msg__PathTrackingError__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_kompass_interfaces
void
kompass_interfaces__msg__PathTrackingError__Sequence__fini(kompass_interfaces__msg__PathTrackingError__Sequence * array);

/// Create array of msg/PathTrackingError messages.
/**
 * It allocates the memory for the array and calls
 * kompass_interfaces__msg__PathTrackingError__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_kompass_interfaces
kompass_interfaces__msg__PathTrackingError__Sequence *
kompass_interfaces__msg__PathTrackingError__Sequence__create(size_t size);

/// Destroy array of msg/PathTrackingError messages.
/**
 * It calls
 * kompass_interfaces__msg__PathTrackingError__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_kompass_interfaces
void
kompass_interfaces__msg__PathTrackingError__Sequence__destroy(kompass_interfaces__msg__PathTrackingError__Sequence * array);

/// Check for msg/PathTrackingError message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_kompass_interfaces
bool
kompass_interfaces__msg__PathTrackingError__Sequence__are_equal(const kompass_interfaces__msg__PathTrackingError__Sequence * lhs, const kompass_interfaces__msg__PathTrackingError__Sequence * rhs);

/// Copy an array of msg/PathTrackingError messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_kompass_interfaces
bool
kompass_interfaces__msg__PathTrackingError__Sequence__copy(
  const kompass_interfaces__msg__PathTrackingError__Sequence * input,
  kompass_interfaces__msg__PathTrackingError__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // KOMPASS_INTERFACES__MSG__DETAIL__PATH_TRACKING_ERROR__FUNCTIONS_H_
