// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from kompass_interfaces:msg/PathTrackingErrorArray.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__MSG__DETAIL__PATH_TRACKING_ERROR_ARRAY__TRAITS_HPP_
#define KOMPASS_INTERFACES__MSG__DETAIL__PATH_TRACKING_ERROR_ARRAY__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "kompass_interfaces/msg/detail/path_tracking_error_array__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace kompass_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const PathTrackingErrorArray & msg,
  std::ostream & out)
{
  out << "{";
  // member: orientation_errors
  {
    if (msg.orientation_errors.size() == 0) {
      out << "orientation_errors: []";
    } else {
      out << "orientation_errors: [";
      size_t pending_items = msg.orientation_errors.size();
      for (auto item : msg.orientation_errors) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: lateral_distance_errors
  {
    if (msg.lateral_distance_errors.size() == 0) {
      out << "lateral_distance_errors: []";
    } else {
      out << "lateral_distance_errors: [";
      size_t pending_items = msg.lateral_distance_errors.size();
      for (auto item : msg.lateral_distance_errors) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PathTrackingErrorArray & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: orientation_errors
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.orientation_errors.size() == 0) {
      out << "orientation_errors: []\n";
    } else {
      out << "orientation_errors:\n";
      for (auto item : msg.orientation_errors) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: lateral_distance_errors
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.lateral_distance_errors.size() == 0) {
      out << "lateral_distance_errors: []\n";
    } else {
      out << "lateral_distance_errors:\n";
      for (auto item : msg.lateral_distance_errors) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PathTrackingErrorArray & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use kompass_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const kompass_interfaces::msg::PathTrackingErrorArray & msg,
  std::ostream & out, size_t indentation = 0)
{
  kompass_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use kompass_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const kompass_interfaces::msg::PathTrackingErrorArray & msg)
{
  return kompass_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<kompass_interfaces::msg::PathTrackingErrorArray>()
{
  return "kompass_interfaces::msg::PathTrackingErrorArray";
}

template<>
inline const char * name<kompass_interfaces::msg::PathTrackingErrorArray>()
{
  return "kompass_interfaces/msg/PathTrackingErrorArray";
}

template<>
struct has_fixed_size<kompass_interfaces::msg::PathTrackingErrorArray>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<kompass_interfaces::msg::PathTrackingErrorArray>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<kompass_interfaces::msg::PathTrackingErrorArray>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // KOMPASS_INTERFACES__MSG__DETAIL__PATH_TRACKING_ERROR_ARRAY__TRAITS_HPP_
