// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from kompass_interfaces:srv/PathFromToFile.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__SRV__DETAIL__PATH_FROM_TO_FILE__TRAITS_HPP_
#define KOMPASS_INTERFACES__SRV__DETAIL__PATH_FROM_TO_FILE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "kompass_interfaces/srv/detail/path_from_to_file__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace kompass_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const PathFromToFile_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: file_location
  {
    out << "file_location: ";
    rosidl_generator_traits::value_to_yaml(msg.file_location, out);
    out << ", ";
  }

  // member: file_name
  {
    out << "file_name: ";
    rosidl_generator_traits::value_to_yaml(msg.file_name, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PathFromToFile_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: file_location
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "file_location: ";
    rosidl_generator_traits::value_to_yaml(msg.file_location, out);
    out << "\n";
  }

  // member: file_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "file_name: ";
    rosidl_generator_traits::value_to_yaml(msg.file_name, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PathFromToFile_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use kompass_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const kompass_interfaces::srv::PathFromToFile_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  kompass_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use kompass_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const kompass_interfaces::srv::PathFromToFile_Request & msg)
{
  return kompass_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<kompass_interfaces::srv::PathFromToFile_Request>()
{
  return "kompass_interfaces::srv::PathFromToFile_Request";
}

template<>
inline const char * name<kompass_interfaces::srv::PathFromToFile_Request>()
{
  return "kompass_interfaces/srv/PathFromToFile_Request";
}

template<>
struct has_fixed_size<kompass_interfaces::srv::PathFromToFile_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<kompass_interfaces::srv::PathFromToFile_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<kompass_interfaces::srv::PathFromToFile_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'global_path'
#include "nav_msgs/msg/detail/path__traits.hpp"

namespace kompass_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const PathFromToFile_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: path_length
  {
    out << "path_length: ";
    rosidl_generator_traits::value_to_yaml(msg.path_length, out);
    out << ", ";
  }

  // member: global_path
  {
    out << "global_path: ";
    to_flow_style_yaml(msg.global_path, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PathFromToFile_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: path_length
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "path_length: ";
    rosidl_generator_traits::value_to_yaml(msg.path_length, out);
    out << "\n";
  }

  // member: global_path
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "global_path:\n";
    to_block_style_yaml(msg.global_path, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PathFromToFile_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use kompass_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const kompass_interfaces::srv::PathFromToFile_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  kompass_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use kompass_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const kompass_interfaces::srv::PathFromToFile_Response & msg)
{
  return kompass_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<kompass_interfaces::srv::PathFromToFile_Response>()
{
  return "kompass_interfaces::srv::PathFromToFile_Response";
}

template<>
inline const char * name<kompass_interfaces::srv::PathFromToFile_Response>()
{
  return "kompass_interfaces/srv/PathFromToFile_Response";
}

template<>
struct has_fixed_size<kompass_interfaces::srv::PathFromToFile_Response>
  : std::integral_constant<bool, has_fixed_size<nav_msgs::msg::Path>::value> {};

template<>
struct has_bounded_size<kompass_interfaces::srv::PathFromToFile_Response>
  : std::integral_constant<bool, has_bounded_size<nav_msgs::msg::Path>::value> {};

template<>
struct is_message<kompass_interfaces::srv::PathFromToFile_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<kompass_interfaces::srv::PathFromToFile>()
{
  return "kompass_interfaces::srv::PathFromToFile";
}

template<>
inline const char * name<kompass_interfaces::srv::PathFromToFile>()
{
  return "kompass_interfaces/srv/PathFromToFile";
}

template<>
struct has_fixed_size<kompass_interfaces::srv::PathFromToFile>
  : std::integral_constant<
    bool,
    has_fixed_size<kompass_interfaces::srv::PathFromToFile_Request>::value &&
    has_fixed_size<kompass_interfaces::srv::PathFromToFile_Response>::value
  >
{
};

template<>
struct has_bounded_size<kompass_interfaces::srv::PathFromToFile>
  : std::integral_constant<
    bool,
    has_bounded_size<kompass_interfaces::srv::PathFromToFile_Request>::value &&
    has_bounded_size<kompass_interfaces::srv::PathFromToFile_Response>::value
  >
{
};

template<>
struct is_service<kompass_interfaces::srv::PathFromToFile>
  : std::true_type
{
};

template<>
struct is_service_request<kompass_interfaces::srv::PathFromToFile_Request>
  : std::true_type
{
};

template<>
struct is_service_response<kompass_interfaces::srv::PathFromToFile_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // KOMPASS_INTERFACES__SRV__DETAIL__PATH_FROM_TO_FILE__TRAITS_HPP_
