// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from kompass_interfaces:action/ControlPath.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__ACTION__DETAIL__CONTROL_PATH__BUILDER_HPP_
#define KOMPASS_INTERFACES__ACTION__DETAIL__CONTROL_PATH__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "kompass_interfaces/action/detail/control_path__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_ControlPath_Goal_controller
{
public:
  explicit Init_ControlPath_Goal_controller(::kompass_interfaces::action::ControlPath_Goal & msg)
  : msg_(msg)
  {}
  ::kompass_interfaces::action::ControlPath_Goal controller(::kompass_interfaces::action::ControlPath_Goal::_controller_type arg)
  {
    msg_.controller = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::ControlPath_Goal msg_;
};

class Init_ControlPath_Goal_path_file_location
{
public:
  explicit Init_ControlPath_Goal_path_file_location(::kompass_interfaces::action::ControlPath_Goal & msg)
  : msg_(msg)
  {}
  Init_ControlPath_Goal_controller path_file_location(::kompass_interfaces::action::ControlPath_Goal::_path_file_location_type arg)
  {
    msg_.path_file_location = std::move(arg);
    return Init_ControlPath_Goal_controller(msg_);
  }

private:
  ::kompass_interfaces::action::ControlPath_Goal msg_;
};

class Init_ControlPath_Goal_path_name
{
public:
  explicit Init_ControlPath_Goal_path_name(::kompass_interfaces::action::ControlPath_Goal & msg)
  : msg_(msg)
  {}
  Init_ControlPath_Goal_path_file_location path_name(::kompass_interfaces::action::ControlPath_Goal::_path_name_type arg)
  {
    msg_.path_name = std::move(arg);
    return Init_ControlPath_Goal_path_file_location(msg_);
  }

private:
  ::kompass_interfaces::action::ControlPath_Goal msg_;
};

class Init_ControlPath_Goal_path_source
{
public:
  Init_ControlPath_Goal_path_source()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_ControlPath_Goal_path_name path_source(::kompass_interfaces::action::ControlPath_Goal::_path_source_type arg)
  {
    msg_.path_source = std::move(arg);
    return Init_ControlPath_Goal_path_name(msg_);
  }

private:
  ::kompass_interfaces::action::ControlPath_Goal msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::ControlPath_Goal>()
{
  return kompass_interfaces::action::builder::Init_ControlPath_Goal_path_source();
}

}  // namespace kompass_interfaces


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_ControlPath_Result_destination_error
{
public:
  Init_ControlPath_Result_destination_error()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  ::kompass_interfaces::action::ControlPath_Result destination_error(::kompass_interfaces::action::ControlPath_Result::_destination_error_type arg)
  {
    msg_.destination_error = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::ControlPath_Result msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::ControlPath_Result>()
{
  return kompass_interfaces::action::builder::Init_ControlPath_Result_destination_error();
}

}  // namespace kompass_interfaces


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_ControlPath_Feedback_control_list
{
public:
  explicit Init_ControlPath_Feedback_control_list(::kompass_interfaces::action::ControlPath_Feedback & msg)
  : msg_(msg)
  {}
  ::kompass_interfaces::action::ControlPath_Feedback control_list(::kompass_interfaces::action::ControlPath_Feedback::_control_list_type arg)
  {
    msg_.control_list = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::ControlPath_Feedback msg_;
};

class Init_ControlPath_Feedback_control
{
public:
  explicit Init_ControlPath_Feedback_control(::kompass_interfaces::action::ControlPath_Feedback & msg)
  : msg_(msg)
  {}
  Init_ControlPath_Feedback_control_list control(::kompass_interfaces::action::ControlPath_Feedback::_control_type arg)
  {
    msg_.control = std::move(arg);
    return Init_ControlPath_Feedback_control_list(msg_);
  }

private:
  ::kompass_interfaces::action::ControlPath_Feedback msg_;
};

class Init_ControlPath_Feedback_compute_time
{
public:
  explicit Init_ControlPath_Feedback_compute_time(::kompass_interfaces::action::ControlPath_Feedback & msg)
  : msg_(msg)
  {}
  Init_ControlPath_Feedback_control compute_time(::kompass_interfaces::action::ControlPath_Feedback::_compute_time_type arg)
  {
    msg_.compute_time = std::move(arg);
    return Init_ControlPath_Feedback_control(msg_);
  }

private:
  ::kompass_interfaces::action::ControlPath_Feedback msg_;
};

class Init_ControlPath_Feedback_prediction_horizon
{
public:
  explicit Init_ControlPath_Feedback_prediction_horizon(::kompass_interfaces::action::ControlPath_Feedback & msg)
  : msg_(msg)
  {}
  Init_ControlPath_Feedback_compute_time prediction_horizon(::kompass_interfaces::action::ControlPath_Feedback::_prediction_horizon_type arg)
  {
    msg_.prediction_horizon = std::move(arg);
    return Init_ControlPath_Feedback_compute_time(msg_);
  }

private:
  ::kompass_interfaces::action::ControlPath_Feedback msg_;
};

class Init_ControlPath_Feedback_global_path_deviation
{
public:
  Init_ControlPath_Feedback_global_path_deviation()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_ControlPath_Feedback_prediction_horizon global_path_deviation(::kompass_interfaces::action::ControlPath_Feedback::_global_path_deviation_type arg)
  {
    msg_.global_path_deviation = std::move(arg);
    return Init_ControlPath_Feedback_prediction_horizon(msg_);
  }

private:
  ::kompass_interfaces::action::ControlPath_Feedback msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::ControlPath_Feedback>()
{
  return kompass_interfaces::action::builder::Init_ControlPath_Feedback_global_path_deviation();
}

}  // namespace kompass_interfaces


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_ControlPath_SendGoal_Request_goal
{
public:
  explicit Init_ControlPath_SendGoal_Request_goal(::kompass_interfaces::action::ControlPath_SendGoal_Request & msg)
  : msg_(msg)
  {}
  ::kompass_interfaces::action::ControlPath_SendGoal_Request goal(::kompass_interfaces::action::ControlPath_SendGoal_Request::_goal_type arg)
  {
    msg_.goal = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::ControlPath_SendGoal_Request msg_;
};

class Init_ControlPath_SendGoal_Request_goal_id
{
public:
  Init_ControlPath_SendGoal_Request_goal_id()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_ControlPath_SendGoal_Request_goal goal_id(::kompass_interfaces::action::ControlPath_SendGoal_Request::_goal_id_type arg)
  {
    msg_.goal_id = std::move(arg);
    return Init_ControlPath_SendGoal_Request_goal(msg_);
  }

private:
  ::kompass_interfaces::action::ControlPath_SendGoal_Request msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::ControlPath_SendGoal_Request>()
{
  return kompass_interfaces::action::builder::Init_ControlPath_SendGoal_Request_goal_id();
}

}  // namespace kompass_interfaces


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_ControlPath_SendGoal_Response_stamp
{
public:
  explicit Init_ControlPath_SendGoal_Response_stamp(::kompass_interfaces::action::ControlPath_SendGoal_Response & msg)
  : msg_(msg)
  {}
  ::kompass_interfaces::action::ControlPath_SendGoal_Response stamp(::kompass_interfaces::action::ControlPath_SendGoal_Response::_stamp_type arg)
  {
    msg_.stamp = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::ControlPath_SendGoal_Response msg_;
};

class Init_ControlPath_SendGoal_Response_accepted
{
public:
  Init_ControlPath_SendGoal_Response_accepted()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_ControlPath_SendGoal_Response_stamp accepted(::kompass_interfaces::action::ControlPath_SendGoal_Response::_accepted_type arg)
  {
    msg_.accepted = std::move(arg);
    return Init_ControlPath_SendGoal_Response_stamp(msg_);
  }

private:
  ::kompass_interfaces::action::ControlPath_SendGoal_Response msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::ControlPath_SendGoal_Response>()
{
  return kompass_interfaces::action::builder::Init_ControlPath_SendGoal_Response_accepted();
}

}  // namespace kompass_interfaces


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_ControlPath_GetResult_Request_goal_id
{
public:
  Init_ControlPath_GetResult_Request_goal_id()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  ::kompass_interfaces::action::ControlPath_GetResult_Request goal_id(::kompass_interfaces::action::ControlPath_GetResult_Request::_goal_id_type arg)
  {
    msg_.goal_id = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::ControlPath_GetResult_Request msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::ControlPath_GetResult_Request>()
{
  return kompass_interfaces::action::builder::Init_ControlPath_GetResult_Request_goal_id();
}

}  // namespace kompass_interfaces


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_ControlPath_GetResult_Response_result
{
public:
  explicit Init_ControlPath_GetResult_Response_result(::kompass_interfaces::action::ControlPath_GetResult_Response & msg)
  : msg_(msg)
  {}
  ::kompass_interfaces::action::ControlPath_GetResult_Response result(::kompass_interfaces::action::ControlPath_GetResult_Response::_result_type arg)
  {
    msg_.result = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::ControlPath_GetResult_Response msg_;
};

class Init_ControlPath_GetResult_Response_status
{
public:
  Init_ControlPath_GetResult_Response_status()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_ControlPath_GetResult_Response_result status(::kompass_interfaces::action::ControlPath_GetResult_Response::_status_type arg)
  {
    msg_.status = std::move(arg);
    return Init_ControlPath_GetResult_Response_result(msg_);
  }

private:
  ::kompass_interfaces::action::ControlPath_GetResult_Response msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::ControlPath_GetResult_Response>()
{
  return kompass_interfaces::action::builder::Init_ControlPath_GetResult_Response_status();
}

}  // namespace kompass_interfaces


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_ControlPath_FeedbackMessage_feedback
{
public:
  explicit Init_ControlPath_FeedbackMessage_feedback(::kompass_interfaces::action::ControlPath_FeedbackMessage & msg)
  : msg_(msg)
  {}
  ::kompass_interfaces::action::ControlPath_FeedbackMessage feedback(::kompass_interfaces::action::ControlPath_FeedbackMessage::_feedback_type arg)
  {
    msg_.feedback = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::ControlPath_FeedbackMessage msg_;
};

class Init_ControlPath_FeedbackMessage_goal_id
{
public:
  Init_ControlPath_FeedbackMessage_goal_id()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_ControlPath_FeedbackMessage_feedback goal_id(::kompass_interfaces::action::ControlPath_FeedbackMessage::_goal_id_type arg)
  {
    msg_.goal_id = std::move(arg);
    return Init_ControlPath_FeedbackMessage_feedback(msg_);
  }

private:
  ::kompass_interfaces::action::ControlPath_FeedbackMessage msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::ControlPath_FeedbackMessage>()
{
  return kompass_interfaces::action::builder::Init_ControlPath_FeedbackMessage_goal_id();
}

}  // namespace kompass_interfaces

#endif  // KOMPASS_INTERFACES__ACTION__DETAIL__CONTROL_PATH__BUILDER_HPP_
