// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from kompass_interfaces:action/ControlPath.idl
// generated code does not contain a copyright notice
#include "kompass_interfaces/action/detail/control_path__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `path_name`
// Member `path_file_location`
#include "rosidl_runtime_c/string_functions.h"

bool
kompass_interfaces__action__ControlPath_Goal__init(kompass_interfaces__action__ControlPath_Goal * msg)
{
  if (!msg) {
    return false;
  }
  // path_source
  // path_name
  if (!rosidl_runtime_c__String__init(&msg->path_name)) {
    kompass_interfaces__action__ControlPath_Goal__fini(msg);
    return false;
  }
  // path_file_location
  if (!rosidl_runtime_c__String__init(&msg->path_file_location)) {
    kompass_interfaces__action__ControlPath_Goal__fini(msg);
    return false;
  }
  // controller
  return true;
}

void
kompass_interfaces__action__ControlPath_Goal__fini(kompass_interfaces__action__ControlPath_Goal * msg)
{
  if (!msg) {
    return;
  }
  // path_source
  // path_name
  rosidl_runtime_c__String__fini(&msg->path_name);
  // path_file_location
  rosidl_runtime_c__String__fini(&msg->path_file_location);
  // controller
}

bool
kompass_interfaces__action__ControlPath_Goal__are_equal(const kompass_interfaces__action__ControlPath_Goal * lhs, const kompass_interfaces__action__ControlPath_Goal * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // path_source
  if (lhs->path_source != rhs->path_source) {
    return false;
  }
  // path_name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->path_name), &(rhs->path_name)))
  {
    return false;
  }
  // path_file_location
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->path_file_location), &(rhs->path_file_location)))
  {
    return false;
  }
  // controller
  if (lhs->controller != rhs->controller) {
    return false;
  }
  return true;
}

bool
kompass_interfaces__action__ControlPath_Goal__copy(
  const kompass_interfaces__action__ControlPath_Goal * input,
  kompass_interfaces__action__ControlPath_Goal * output)
{
  if (!input || !output) {
    return false;
  }
  // path_source
  output->path_source = input->path_source;
  // path_name
  if (!rosidl_runtime_c__String__copy(
      &(input->path_name), &(output->path_name)))
  {
    return false;
  }
  // path_file_location
  if (!rosidl_runtime_c__String__copy(
      &(input->path_file_location), &(output->path_file_location)))
  {
    return false;
  }
  // controller
  output->controller = input->controller;
  return true;
}

kompass_interfaces__action__ControlPath_Goal *
kompass_interfaces__action__ControlPath_Goal__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__action__ControlPath_Goal * msg = (kompass_interfaces__action__ControlPath_Goal *)allocator.allocate(sizeof(kompass_interfaces__action__ControlPath_Goal), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(kompass_interfaces__action__ControlPath_Goal));
  bool success = kompass_interfaces__action__ControlPath_Goal__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
kompass_interfaces__action__ControlPath_Goal__destroy(kompass_interfaces__action__ControlPath_Goal * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    kompass_interfaces__action__ControlPath_Goal__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
kompass_interfaces__action__ControlPath_Goal__Sequence__init(kompass_interfaces__action__ControlPath_Goal__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__action__ControlPath_Goal * data = NULL;

  if (size) {
    data = (kompass_interfaces__action__ControlPath_Goal *)allocator.zero_allocate(size, sizeof(kompass_interfaces__action__ControlPath_Goal), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = kompass_interfaces__action__ControlPath_Goal__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        kompass_interfaces__action__ControlPath_Goal__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
kompass_interfaces__action__ControlPath_Goal__Sequence__fini(kompass_interfaces__action__ControlPath_Goal__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      kompass_interfaces__action__ControlPath_Goal__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

kompass_interfaces__action__ControlPath_Goal__Sequence *
kompass_interfaces__action__ControlPath_Goal__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__action__ControlPath_Goal__Sequence * array = (kompass_interfaces__action__ControlPath_Goal__Sequence *)allocator.allocate(sizeof(kompass_interfaces__action__ControlPath_Goal__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = kompass_interfaces__action__ControlPath_Goal__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
kompass_interfaces__action__ControlPath_Goal__Sequence__destroy(kompass_interfaces__action__ControlPath_Goal__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    kompass_interfaces__action__ControlPath_Goal__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
kompass_interfaces__action__ControlPath_Goal__Sequence__are_equal(const kompass_interfaces__action__ControlPath_Goal__Sequence * lhs, const kompass_interfaces__action__ControlPath_Goal__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!kompass_interfaces__action__ControlPath_Goal__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
kompass_interfaces__action__ControlPath_Goal__Sequence__copy(
  const kompass_interfaces__action__ControlPath_Goal__Sequence * input,
  kompass_interfaces__action__ControlPath_Goal__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(kompass_interfaces__action__ControlPath_Goal);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    kompass_interfaces__action__ControlPath_Goal * data =
      (kompass_interfaces__action__ControlPath_Goal *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!kompass_interfaces__action__ControlPath_Goal__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          kompass_interfaces__action__ControlPath_Goal__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!kompass_interfaces__action__ControlPath_Goal__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `destination_error`
#include "kompass_interfaces/msg/detail/path_tracking_error__functions.h"

bool
kompass_interfaces__action__ControlPath_Result__init(kompass_interfaces__action__ControlPath_Result * msg)
{
  if (!msg) {
    return false;
  }
  // destination_error
  if (!kompass_interfaces__msg__PathTrackingError__init(&msg->destination_error)) {
    kompass_interfaces__action__ControlPath_Result__fini(msg);
    return false;
  }
  return true;
}

void
kompass_interfaces__action__ControlPath_Result__fini(kompass_interfaces__action__ControlPath_Result * msg)
{
  if (!msg) {
    return;
  }
  // destination_error
  kompass_interfaces__msg__PathTrackingError__fini(&msg->destination_error);
}

bool
kompass_interfaces__action__ControlPath_Result__are_equal(const kompass_interfaces__action__ControlPath_Result * lhs, const kompass_interfaces__action__ControlPath_Result * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // destination_error
  if (!kompass_interfaces__msg__PathTrackingError__are_equal(
      &(lhs->destination_error), &(rhs->destination_error)))
  {
    return false;
  }
  return true;
}

bool
kompass_interfaces__action__ControlPath_Result__copy(
  const kompass_interfaces__action__ControlPath_Result * input,
  kompass_interfaces__action__ControlPath_Result * output)
{
  if (!input || !output) {
    return false;
  }
  // destination_error
  if (!kompass_interfaces__msg__PathTrackingError__copy(
      &(input->destination_error), &(output->destination_error)))
  {
    return false;
  }
  return true;
}

kompass_interfaces__action__ControlPath_Result *
kompass_interfaces__action__ControlPath_Result__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__action__ControlPath_Result * msg = (kompass_interfaces__action__ControlPath_Result *)allocator.allocate(sizeof(kompass_interfaces__action__ControlPath_Result), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(kompass_interfaces__action__ControlPath_Result));
  bool success = kompass_interfaces__action__ControlPath_Result__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
kompass_interfaces__action__ControlPath_Result__destroy(kompass_interfaces__action__ControlPath_Result * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    kompass_interfaces__action__ControlPath_Result__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
kompass_interfaces__action__ControlPath_Result__Sequence__init(kompass_interfaces__action__ControlPath_Result__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__action__ControlPath_Result * data = NULL;

  if (size) {
    data = (kompass_interfaces__action__ControlPath_Result *)allocator.zero_allocate(size, sizeof(kompass_interfaces__action__ControlPath_Result), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = kompass_interfaces__action__ControlPath_Result__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        kompass_interfaces__action__ControlPath_Result__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
kompass_interfaces__action__ControlPath_Result__Sequence__fini(kompass_interfaces__action__ControlPath_Result__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      kompass_interfaces__action__ControlPath_Result__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

kompass_interfaces__action__ControlPath_Result__Sequence *
kompass_interfaces__action__ControlPath_Result__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__action__ControlPath_Result__Sequence * array = (kompass_interfaces__action__ControlPath_Result__Sequence *)allocator.allocate(sizeof(kompass_interfaces__action__ControlPath_Result__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = kompass_interfaces__action__ControlPath_Result__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
kompass_interfaces__action__ControlPath_Result__Sequence__destroy(kompass_interfaces__action__ControlPath_Result__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    kompass_interfaces__action__ControlPath_Result__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
kompass_interfaces__action__ControlPath_Result__Sequence__are_equal(const kompass_interfaces__action__ControlPath_Result__Sequence * lhs, const kompass_interfaces__action__ControlPath_Result__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!kompass_interfaces__action__ControlPath_Result__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
kompass_interfaces__action__ControlPath_Result__Sequence__copy(
  const kompass_interfaces__action__ControlPath_Result__Sequence * input,
  kompass_interfaces__action__ControlPath_Result__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(kompass_interfaces__action__ControlPath_Result);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    kompass_interfaces__action__ControlPath_Result * data =
      (kompass_interfaces__action__ControlPath_Result *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!kompass_interfaces__action__ControlPath_Result__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          kompass_interfaces__action__ControlPath_Result__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!kompass_interfaces__action__ControlPath_Result__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `global_path_deviation`
// already included above
// #include "kompass_interfaces/msg/detail/path_tracking_error__functions.h"
// Member `control`
#include "geometry_msgs/msg/detail/twist__functions.h"
// Member `control_list`
#include "kompass_interfaces/msg/detail/twist_array__functions.h"

bool
kompass_interfaces__action__ControlPath_Feedback__init(kompass_interfaces__action__ControlPath_Feedback * msg)
{
  if (!msg) {
    return false;
  }
  // global_path_deviation
  if (!kompass_interfaces__msg__PathTrackingError__init(&msg->global_path_deviation)) {
    kompass_interfaces__action__ControlPath_Feedback__fini(msg);
    return false;
  }
  // prediction_horizon
  // compute_time
  // control
  if (!geometry_msgs__msg__Twist__init(&msg->control)) {
    kompass_interfaces__action__ControlPath_Feedback__fini(msg);
    return false;
  }
  // control_list
  if (!kompass_interfaces__msg__TwistArray__init(&msg->control_list)) {
    kompass_interfaces__action__ControlPath_Feedback__fini(msg);
    return false;
  }
  return true;
}

void
kompass_interfaces__action__ControlPath_Feedback__fini(kompass_interfaces__action__ControlPath_Feedback * msg)
{
  if (!msg) {
    return;
  }
  // global_path_deviation
  kompass_interfaces__msg__PathTrackingError__fini(&msg->global_path_deviation);
  // prediction_horizon
  // compute_time
  // control
  geometry_msgs__msg__Twist__fini(&msg->control);
  // control_list
  kompass_interfaces__msg__TwistArray__fini(&msg->control_list);
}

bool
kompass_interfaces__action__ControlPath_Feedback__are_equal(const kompass_interfaces__action__ControlPath_Feedback * lhs, const kompass_interfaces__action__ControlPath_Feedback * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // global_path_deviation
  if (!kompass_interfaces__msg__PathTrackingError__are_equal(
      &(lhs->global_path_deviation), &(rhs->global_path_deviation)))
  {
    return false;
  }
  // prediction_horizon
  if (lhs->prediction_horizon != rhs->prediction_horizon) {
    return false;
  }
  // compute_time
  if (lhs->compute_time != rhs->compute_time) {
    return false;
  }
  // control
  if (!geometry_msgs__msg__Twist__are_equal(
      &(lhs->control), &(rhs->control)))
  {
    return false;
  }
  // control_list
  if (!kompass_interfaces__msg__TwistArray__are_equal(
      &(lhs->control_list), &(rhs->control_list)))
  {
    return false;
  }
  return true;
}

bool
kompass_interfaces__action__ControlPath_Feedback__copy(
  const kompass_interfaces__action__ControlPath_Feedback * input,
  kompass_interfaces__action__ControlPath_Feedback * output)
{
  if (!input || !output) {
    return false;
  }
  // global_path_deviation
  if (!kompass_interfaces__msg__PathTrackingError__copy(
      &(input->global_path_deviation), &(output->global_path_deviation)))
  {
    return false;
  }
  // prediction_horizon
  output->prediction_horizon = input->prediction_horizon;
  // compute_time
  output->compute_time = input->compute_time;
  // control
  if (!geometry_msgs__msg__Twist__copy(
      &(input->control), &(output->control)))
  {
    return false;
  }
  // control_list
  if (!kompass_interfaces__msg__TwistArray__copy(
      &(input->control_list), &(output->control_list)))
  {
    return false;
  }
  return true;
}

kompass_interfaces__action__ControlPath_Feedback *
kompass_interfaces__action__ControlPath_Feedback__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__action__ControlPath_Feedback * msg = (kompass_interfaces__action__ControlPath_Feedback *)allocator.allocate(sizeof(kompass_interfaces__action__ControlPath_Feedback), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(kompass_interfaces__action__ControlPath_Feedback));
  bool success = kompass_interfaces__action__ControlPath_Feedback__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
kompass_interfaces__action__ControlPath_Feedback__destroy(kompass_interfaces__action__ControlPath_Feedback * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    kompass_interfaces__action__ControlPath_Feedback__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
kompass_interfaces__action__ControlPath_Feedback__Sequence__init(kompass_interfaces__action__ControlPath_Feedback__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__action__ControlPath_Feedback * data = NULL;

  if (size) {
    data = (kompass_interfaces__action__ControlPath_Feedback *)allocator.zero_allocate(size, sizeof(kompass_interfaces__action__ControlPath_Feedback), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = kompass_interfaces__action__ControlPath_Feedback__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        kompass_interfaces__action__ControlPath_Feedback__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
kompass_interfaces__action__ControlPath_Feedback__Sequence__fini(kompass_interfaces__action__ControlPath_Feedback__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      kompass_interfaces__action__ControlPath_Feedback__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

kompass_interfaces__action__ControlPath_Feedback__Sequence *
kompass_interfaces__action__ControlPath_Feedback__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__action__ControlPath_Feedback__Sequence * array = (kompass_interfaces__action__ControlPath_Feedback__Sequence *)allocator.allocate(sizeof(kompass_interfaces__action__ControlPath_Feedback__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = kompass_interfaces__action__ControlPath_Feedback__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
kompass_interfaces__action__ControlPath_Feedback__Sequence__destroy(kompass_interfaces__action__ControlPath_Feedback__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    kompass_interfaces__action__ControlPath_Feedback__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
kompass_interfaces__action__ControlPath_Feedback__Sequence__are_equal(const kompass_interfaces__action__ControlPath_Feedback__Sequence * lhs, const kompass_interfaces__action__ControlPath_Feedback__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!kompass_interfaces__action__ControlPath_Feedback__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
kompass_interfaces__action__ControlPath_Feedback__Sequence__copy(
  const kompass_interfaces__action__ControlPath_Feedback__Sequence * input,
  kompass_interfaces__action__ControlPath_Feedback__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(kompass_interfaces__action__ControlPath_Feedback);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    kompass_interfaces__action__ControlPath_Feedback * data =
      (kompass_interfaces__action__ControlPath_Feedback *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!kompass_interfaces__action__ControlPath_Feedback__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          kompass_interfaces__action__ControlPath_Feedback__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!kompass_interfaces__action__ControlPath_Feedback__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `goal_id`
#include "unique_identifier_msgs/msg/detail/uuid__functions.h"
// Member `goal`
// already included above
// #include "kompass_interfaces/action/detail/control_path__functions.h"

bool
kompass_interfaces__action__ControlPath_SendGoal_Request__init(kompass_interfaces__action__ControlPath_SendGoal_Request * msg)
{
  if (!msg) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__init(&msg->goal_id)) {
    kompass_interfaces__action__ControlPath_SendGoal_Request__fini(msg);
    return false;
  }
  // goal
  if (!kompass_interfaces__action__ControlPath_Goal__init(&msg->goal)) {
    kompass_interfaces__action__ControlPath_SendGoal_Request__fini(msg);
    return false;
  }
  return true;
}

void
kompass_interfaces__action__ControlPath_SendGoal_Request__fini(kompass_interfaces__action__ControlPath_SendGoal_Request * msg)
{
  if (!msg) {
    return;
  }
  // goal_id
  unique_identifier_msgs__msg__UUID__fini(&msg->goal_id);
  // goal
  kompass_interfaces__action__ControlPath_Goal__fini(&msg->goal);
}

bool
kompass_interfaces__action__ControlPath_SendGoal_Request__are_equal(const kompass_interfaces__action__ControlPath_SendGoal_Request * lhs, const kompass_interfaces__action__ControlPath_SendGoal_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__are_equal(
      &(lhs->goal_id), &(rhs->goal_id)))
  {
    return false;
  }
  // goal
  if (!kompass_interfaces__action__ControlPath_Goal__are_equal(
      &(lhs->goal), &(rhs->goal)))
  {
    return false;
  }
  return true;
}

bool
kompass_interfaces__action__ControlPath_SendGoal_Request__copy(
  const kompass_interfaces__action__ControlPath_SendGoal_Request * input,
  kompass_interfaces__action__ControlPath_SendGoal_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__copy(
      &(input->goal_id), &(output->goal_id)))
  {
    return false;
  }
  // goal
  if (!kompass_interfaces__action__ControlPath_Goal__copy(
      &(input->goal), &(output->goal)))
  {
    return false;
  }
  return true;
}

kompass_interfaces__action__ControlPath_SendGoal_Request *
kompass_interfaces__action__ControlPath_SendGoal_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__action__ControlPath_SendGoal_Request * msg = (kompass_interfaces__action__ControlPath_SendGoal_Request *)allocator.allocate(sizeof(kompass_interfaces__action__ControlPath_SendGoal_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(kompass_interfaces__action__ControlPath_SendGoal_Request));
  bool success = kompass_interfaces__action__ControlPath_SendGoal_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
kompass_interfaces__action__ControlPath_SendGoal_Request__destroy(kompass_interfaces__action__ControlPath_SendGoal_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    kompass_interfaces__action__ControlPath_SendGoal_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
kompass_interfaces__action__ControlPath_SendGoal_Request__Sequence__init(kompass_interfaces__action__ControlPath_SendGoal_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__action__ControlPath_SendGoal_Request * data = NULL;

  if (size) {
    data = (kompass_interfaces__action__ControlPath_SendGoal_Request *)allocator.zero_allocate(size, sizeof(kompass_interfaces__action__ControlPath_SendGoal_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = kompass_interfaces__action__ControlPath_SendGoal_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        kompass_interfaces__action__ControlPath_SendGoal_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
kompass_interfaces__action__ControlPath_SendGoal_Request__Sequence__fini(kompass_interfaces__action__ControlPath_SendGoal_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      kompass_interfaces__action__ControlPath_SendGoal_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

kompass_interfaces__action__ControlPath_SendGoal_Request__Sequence *
kompass_interfaces__action__ControlPath_SendGoal_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__action__ControlPath_SendGoal_Request__Sequence * array = (kompass_interfaces__action__ControlPath_SendGoal_Request__Sequence *)allocator.allocate(sizeof(kompass_interfaces__action__ControlPath_SendGoal_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = kompass_interfaces__action__ControlPath_SendGoal_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
kompass_interfaces__action__ControlPath_SendGoal_Request__Sequence__destroy(kompass_interfaces__action__ControlPath_SendGoal_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    kompass_interfaces__action__ControlPath_SendGoal_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
kompass_interfaces__action__ControlPath_SendGoal_Request__Sequence__are_equal(const kompass_interfaces__action__ControlPath_SendGoal_Request__Sequence * lhs, const kompass_interfaces__action__ControlPath_SendGoal_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!kompass_interfaces__action__ControlPath_SendGoal_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
kompass_interfaces__action__ControlPath_SendGoal_Request__Sequence__copy(
  const kompass_interfaces__action__ControlPath_SendGoal_Request__Sequence * input,
  kompass_interfaces__action__ControlPath_SendGoal_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(kompass_interfaces__action__ControlPath_SendGoal_Request);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    kompass_interfaces__action__ControlPath_SendGoal_Request * data =
      (kompass_interfaces__action__ControlPath_SendGoal_Request *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!kompass_interfaces__action__ControlPath_SendGoal_Request__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          kompass_interfaces__action__ControlPath_SendGoal_Request__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!kompass_interfaces__action__ControlPath_SendGoal_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `stamp`
#include "builtin_interfaces/msg/detail/time__functions.h"

bool
kompass_interfaces__action__ControlPath_SendGoal_Response__init(kompass_interfaces__action__ControlPath_SendGoal_Response * msg)
{
  if (!msg) {
    return false;
  }
  // accepted
  // stamp
  if (!builtin_interfaces__msg__Time__init(&msg->stamp)) {
    kompass_interfaces__action__ControlPath_SendGoal_Response__fini(msg);
    return false;
  }
  return true;
}

void
kompass_interfaces__action__ControlPath_SendGoal_Response__fini(kompass_interfaces__action__ControlPath_SendGoal_Response * msg)
{
  if (!msg) {
    return;
  }
  // accepted
  // stamp
  builtin_interfaces__msg__Time__fini(&msg->stamp);
}

bool
kompass_interfaces__action__ControlPath_SendGoal_Response__are_equal(const kompass_interfaces__action__ControlPath_SendGoal_Response * lhs, const kompass_interfaces__action__ControlPath_SendGoal_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // accepted
  if (lhs->accepted != rhs->accepted) {
    return false;
  }
  // stamp
  if (!builtin_interfaces__msg__Time__are_equal(
      &(lhs->stamp), &(rhs->stamp)))
  {
    return false;
  }
  return true;
}

bool
kompass_interfaces__action__ControlPath_SendGoal_Response__copy(
  const kompass_interfaces__action__ControlPath_SendGoal_Response * input,
  kompass_interfaces__action__ControlPath_SendGoal_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // accepted
  output->accepted = input->accepted;
  // stamp
  if (!builtin_interfaces__msg__Time__copy(
      &(input->stamp), &(output->stamp)))
  {
    return false;
  }
  return true;
}

kompass_interfaces__action__ControlPath_SendGoal_Response *
kompass_interfaces__action__ControlPath_SendGoal_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__action__ControlPath_SendGoal_Response * msg = (kompass_interfaces__action__ControlPath_SendGoal_Response *)allocator.allocate(sizeof(kompass_interfaces__action__ControlPath_SendGoal_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(kompass_interfaces__action__ControlPath_SendGoal_Response));
  bool success = kompass_interfaces__action__ControlPath_SendGoal_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
kompass_interfaces__action__ControlPath_SendGoal_Response__destroy(kompass_interfaces__action__ControlPath_SendGoal_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    kompass_interfaces__action__ControlPath_SendGoal_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
kompass_interfaces__action__ControlPath_SendGoal_Response__Sequence__init(kompass_interfaces__action__ControlPath_SendGoal_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__action__ControlPath_SendGoal_Response * data = NULL;

  if (size) {
    data = (kompass_interfaces__action__ControlPath_SendGoal_Response *)allocator.zero_allocate(size, sizeof(kompass_interfaces__action__ControlPath_SendGoal_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = kompass_interfaces__action__ControlPath_SendGoal_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        kompass_interfaces__action__ControlPath_SendGoal_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
kompass_interfaces__action__ControlPath_SendGoal_Response__Sequence__fini(kompass_interfaces__action__ControlPath_SendGoal_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      kompass_interfaces__action__ControlPath_SendGoal_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

kompass_interfaces__action__ControlPath_SendGoal_Response__Sequence *
kompass_interfaces__action__ControlPath_SendGoal_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__action__ControlPath_SendGoal_Response__Sequence * array = (kompass_interfaces__action__ControlPath_SendGoal_Response__Sequence *)allocator.allocate(sizeof(kompass_interfaces__action__ControlPath_SendGoal_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = kompass_interfaces__action__ControlPath_SendGoal_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
kompass_interfaces__action__ControlPath_SendGoal_Response__Sequence__destroy(kompass_interfaces__action__ControlPath_SendGoal_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    kompass_interfaces__action__ControlPath_SendGoal_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
kompass_interfaces__action__ControlPath_SendGoal_Response__Sequence__are_equal(const kompass_interfaces__action__ControlPath_SendGoal_Response__Sequence * lhs, const kompass_interfaces__action__ControlPath_SendGoal_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!kompass_interfaces__action__ControlPath_SendGoal_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
kompass_interfaces__action__ControlPath_SendGoal_Response__Sequence__copy(
  const kompass_interfaces__action__ControlPath_SendGoal_Response__Sequence * input,
  kompass_interfaces__action__ControlPath_SendGoal_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(kompass_interfaces__action__ControlPath_SendGoal_Response);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    kompass_interfaces__action__ControlPath_SendGoal_Response * data =
      (kompass_interfaces__action__ControlPath_SendGoal_Response *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!kompass_interfaces__action__ControlPath_SendGoal_Response__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          kompass_interfaces__action__ControlPath_SendGoal_Response__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!kompass_interfaces__action__ControlPath_SendGoal_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `goal_id`
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__functions.h"

bool
kompass_interfaces__action__ControlPath_GetResult_Request__init(kompass_interfaces__action__ControlPath_GetResult_Request * msg)
{
  if (!msg) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__init(&msg->goal_id)) {
    kompass_interfaces__action__ControlPath_GetResult_Request__fini(msg);
    return false;
  }
  return true;
}

void
kompass_interfaces__action__ControlPath_GetResult_Request__fini(kompass_interfaces__action__ControlPath_GetResult_Request * msg)
{
  if (!msg) {
    return;
  }
  // goal_id
  unique_identifier_msgs__msg__UUID__fini(&msg->goal_id);
}

bool
kompass_interfaces__action__ControlPath_GetResult_Request__are_equal(const kompass_interfaces__action__ControlPath_GetResult_Request * lhs, const kompass_interfaces__action__ControlPath_GetResult_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__are_equal(
      &(lhs->goal_id), &(rhs->goal_id)))
  {
    return false;
  }
  return true;
}

bool
kompass_interfaces__action__ControlPath_GetResult_Request__copy(
  const kompass_interfaces__action__ControlPath_GetResult_Request * input,
  kompass_interfaces__action__ControlPath_GetResult_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__copy(
      &(input->goal_id), &(output->goal_id)))
  {
    return false;
  }
  return true;
}

kompass_interfaces__action__ControlPath_GetResult_Request *
kompass_interfaces__action__ControlPath_GetResult_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__action__ControlPath_GetResult_Request * msg = (kompass_interfaces__action__ControlPath_GetResult_Request *)allocator.allocate(sizeof(kompass_interfaces__action__ControlPath_GetResult_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(kompass_interfaces__action__ControlPath_GetResult_Request));
  bool success = kompass_interfaces__action__ControlPath_GetResult_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
kompass_interfaces__action__ControlPath_GetResult_Request__destroy(kompass_interfaces__action__ControlPath_GetResult_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    kompass_interfaces__action__ControlPath_GetResult_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
kompass_interfaces__action__ControlPath_GetResult_Request__Sequence__init(kompass_interfaces__action__ControlPath_GetResult_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__action__ControlPath_GetResult_Request * data = NULL;

  if (size) {
    data = (kompass_interfaces__action__ControlPath_GetResult_Request *)allocator.zero_allocate(size, sizeof(kompass_interfaces__action__ControlPath_GetResult_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = kompass_interfaces__action__ControlPath_GetResult_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        kompass_interfaces__action__ControlPath_GetResult_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
kompass_interfaces__action__ControlPath_GetResult_Request__Sequence__fini(kompass_interfaces__action__ControlPath_GetResult_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      kompass_interfaces__action__ControlPath_GetResult_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

kompass_interfaces__action__ControlPath_GetResult_Request__Sequence *
kompass_interfaces__action__ControlPath_GetResult_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__action__ControlPath_GetResult_Request__Sequence * array = (kompass_interfaces__action__ControlPath_GetResult_Request__Sequence *)allocator.allocate(sizeof(kompass_interfaces__action__ControlPath_GetResult_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = kompass_interfaces__action__ControlPath_GetResult_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
kompass_interfaces__action__ControlPath_GetResult_Request__Sequence__destroy(kompass_interfaces__action__ControlPath_GetResult_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    kompass_interfaces__action__ControlPath_GetResult_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
kompass_interfaces__action__ControlPath_GetResult_Request__Sequence__are_equal(const kompass_interfaces__action__ControlPath_GetResult_Request__Sequence * lhs, const kompass_interfaces__action__ControlPath_GetResult_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!kompass_interfaces__action__ControlPath_GetResult_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
kompass_interfaces__action__ControlPath_GetResult_Request__Sequence__copy(
  const kompass_interfaces__action__ControlPath_GetResult_Request__Sequence * input,
  kompass_interfaces__action__ControlPath_GetResult_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(kompass_interfaces__action__ControlPath_GetResult_Request);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    kompass_interfaces__action__ControlPath_GetResult_Request * data =
      (kompass_interfaces__action__ControlPath_GetResult_Request *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!kompass_interfaces__action__ControlPath_GetResult_Request__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          kompass_interfaces__action__ControlPath_GetResult_Request__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!kompass_interfaces__action__ControlPath_GetResult_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `result`
// already included above
// #include "kompass_interfaces/action/detail/control_path__functions.h"

bool
kompass_interfaces__action__ControlPath_GetResult_Response__init(kompass_interfaces__action__ControlPath_GetResult_Response * msg)
{
  if (!msg) {
    return false;
  }
  // status
  // result
  if (!kompass_interfaces__action__ControlPath_Result__init(&msg->result)) {
    kompass_interfaces__action__ControlPath_GetResult_Response__fini(msg);
    return false;
  }
  return true;
}

void
kompass_interfaces__action__ControlPath_GetResult_Response__fini(kompass_interfaces__action__ControlPath_GetResult_Response * msg)
{
  if (!msg) {
    return;
  }
  // status
  // result
  kompass_interfaces__action__ControlPath_Result__fini(&msg->result);
}

bool
kompass_interfaces__action__ControlPath_GetResult_Response__are_equal(const kompass_interfaces__action__ControlPath_GetResult_Response * lhs, const kompass_interfaces__action__ControlPath_GetResult_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // status
  if (lhs->status != rhs->status) {
    return false;
  }
  // result
  if (!kompass_interfaces__action__ControlPath_Result__are_equal(
      &(lhs->result), &(rhs->result)))
  {
    return false;
  }
  return true;
}

bool
kompass_interfaces__action__ControlPath_GetResult_Response__copy(
  const kompass_interfaces__action__ControlPath_GetResult_Response * input,
  kompass_interfaces__action__ControlPath_GetResult_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // status
  output->status = input->status;
  // result
  if (!kompass_interfaces__action__ControlPath_Result__copy(
      &(input->result), &(output->result)))
  {
    return false;
  }
  return true;
}

kompass_interfaces__action__ControlPath_GetResult_Response *
kompass_interfaces__action__ControlPath_GetResult_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__action__ControlPath_GetResult_Response * msg = (kompass_interfaces__action__ControlPath_GetResult_Response *)allocator.allocate(sizeof(kompass_interfaces__action__ControlPath_GetResult_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(kompass_interfaces__action__ControlPath_GetResult_Response));
  bool success = kompass_interfaces__action__ControlPath_GetResult_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
kompass_interfaces__action__ControlPath_GetResult_Response__destroy(kompass_interfaces__action__ControlPath_GetResult_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    kompass_interfaces__action__ControlPath_GetResult_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
kompass_interfaces__action__ControlPath_GetResult_Response__Sequence__init(kompass_interfaces__action__ControlPath_GetResult_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__action__ControlPath_GetResult_Response * data = NULL;

  if (size) {
    data = (kompass_interfaces__action__ControlPath_GetResult_Response *)allocator.zero_allocate(size, sizeof(kompass_interfaces__action__ControlPath_GetResult_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = kompass_interfaces__action__ControlPath_GetResult_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        kompass_interfaces__action__ControlPath_GetResult_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
kompass_interfaces__action__ControlPath_GetResult_Response__Sequence__fini(kompass_interfaces__action__ControlPath_GetResult_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      kompass_interfaces__action__ControlPath_GetResult_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

kompass_interfaces__action__ControlPath_GetResult_Response__Sequence *
kompass_interfaces__action__ControlPath_GetResult_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__action__ControlPath_GetResult_Response__Sequence * array = (kompass_interfaces__action__ControlPath_GetResult_Response__Sequence *)allocator.allocate(sizeof(kompass_interfaces__action__ControlPath_GetResult_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = kompass_interfaces__action__ControlPath_GetResult_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
kompass_interfaces__action__ControlPath_GetResult_Response__Sequence__destroy(kompass_interfaces__action__ControlPath_GetResult_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    kompass_interfaces__action__ControlPath_GetResult_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
kompass_interfaces__action__ControlPath_GetResult_Response__Sequence__are_equal(const kompass_interfaces__action__ControlPath_GetResult_Response__Sequence * lhs, const kompass_interfaces__action__ControlPath_GetResult_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!kompass_interfaces__action__ControlPath_GetResult_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
kompass_interfaces__action__ControlPath_GetResult_Response__Sequence__copy(
  const kompass_interfaces__action__ControlPath_GetResult_Response__Sequence * input,
  kompass_interfaces__action__ControlPath_GetResult_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(kompass_interfaces__action__ControlPath_GetResult_Response);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    kompass_interfaces__action__ControlPath_GetResult_Response * data =
      (kompass_interfaces__action__ControlPath_GetResult_Response *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!kompass_interfaces__action__ControlPath_GetResult_Response__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          kompass_interfaces__action__ControlPath_GetResult_Response__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!kompass_interfaces__action__ControlPath_GetResult_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `goal_id`
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__functions.h"
// Member `feedback`
// already included above
// #include "kompass_interfaces/action/detail/control_path__functions.h"

bool
kompass_interfaces__action__ControlPath_FeedbackMessage__init(kompass_interfaces__action__ControlPath_FeedbackMessage * msg)
{
  if (!msg) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__init(&msg->goal_id)) {
    kompass_interfaces__action__ControlPath_FeedbackMessage__fini(msg);
    return false;
  }
  // feedback
  if (!kompass_interfaces__action__ControlPath_Feedback__init(&msg->feedback)) {
    kompass_interfaces__action__ControlPath_FeedbackMessage__fini(msg);
    return false;
  }
  return true;
}

void
kompass_interfaces__action__ControlPath_FeedbackMessage__fini(kompass_interfaces__action__ControlPath_FeedbackMessage * msg)
{
  if (!msg) {
    return;
  }
  // goal_id
  unique_identifier_msgs__msg__UUID__fini(&msg->goal_id);
  // feedback
  kompass_interfaces__action__ControlPath_Feedback__fini(&msg->feedback);
}

bool
kompass_interfaces__action__ControlPath_FeedbackMessage__are_equal(const kompass_interfaces__action__ControlPath_FeedbackMessage * lhs, const kompass_interfaces__action__ControlPath_FeedbackMessage * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__are_equal(
      &(lhs->goal_id), &(rhs->goal_id)))
  {
    return false;
  }
  // feedback
  if (!kompass_interfaces__action__ControlPath_Feedback__are_equal(
      &(lhs->feedback), &(rhs->feedback)))
  {
    return false;
  }
  return true;
}

bool
kompass_interfaces__action__ControlPath_FeedbackMessage__copy(
  const kompass_interfaces__action__ControlPath_FeedbackMessage * input,
  kompass_interfaces__action__ControlPath_FeedbackMessage * output)
{
  if (!input || !output) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__copy(
      &(input->goal_id), &(output->goal_id)))
  {
    return false;
  }
  // feedback
  if (!kompass_interfaces__action__ControlPath_Feedback__copy(
      &(input->feedback), &(output->feedback)))
  {
    return false;
  }
  return true;
}

kompass_interfaces__action__ControlPath_FeedbackMessage *
kompass_interfaces__action__ControlPath_FeedbackMessage__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__action__ControlPath_FeedbackMessage * msg = (kompass_interfaces__action__ControlPath_FeedbackMessage *)allocator.allocate(sizeof(kompass_interfaces__action__ControlPath_FeedbackMessage), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(kompass_interfaces__action__ControlPath_FeedbackMessage));
  bool success = kompass_interfaces__action__ControlPath_FeedbackMessage__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
kompass_interfaces__action__ControlPath_FeedbackMessage__destroy(kompass_interfaces__action__ControlPath_FeedbackMessage * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    kompass_interfaces__action__ControlPath_FeedbackMessage__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
kompass_interfaces__action__ControlPath_FeedbackMessage__Sequence__init(kompass_interfaces__action__ControlPath_FeedbackMessage__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__action__ControlPath_FeedbackMessage * data = NULL;

  if (size) {
    data = (kompass_interfaces__action__ControlPath_FeedbackMessage *)allocator.zero_allocate(size, sizeof(kompass_interfaces__action__ControlPath_FeedbackMessage), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = kompass_interfaces__action__ControlPath_FeedbackMessage__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        kompass_interfaces__action__ControlPath_FeedbackMessage__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
kompass_interfaces__action__ControlPath_FeedbackMessage__Sequence__fini(kompass_interfaces__action__ControlPath_FeedbackMessage__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      kompass_interfaces__action__ControlPath_FeedbackMessage__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

kompass_interfaces__action__ControlPath_FeedbackMessage__Sequence *
kompass_interfaces__action__ControlPath_FeedbackMessage__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__action__ControlPath_FeedbackMessage__Sequence * array = (kompass_interfaces__action__ControlPath_FeedbackMessage__Sequence *)allocator.allocate(sizeof(kompass_interfaces__action__ControlPath_FeedbackMessage__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = kompass_interfaces__action__ControlPath_FeedbackMessage__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
kompass_interfaces__action__ControlPath_FeedbackMessage__Sequence__destroy(kompass_interfaces__action__ControlPath_FeedbackMessage__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    kompass_interfaces__action__ControlPath_FeedbackMessage__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
kompass_interfaces__action__ControlPath_FeedbackMessage__Sequence__are_equal(const kompass_interfaces__action__ControlPath_FeedbackMessage__Sequence * lhs, const kompass_interfaces__action__ControlPath_FeedbackMessage__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!kompass_interfaces__action__ControlPath_FeedbackMessage__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
kompass_interfaces__action__ControlPath_FeedbackMessage__Sequence__copy(
  const kompass_interfaces__action__ControlPath_FeedbackMessage__Sequence * input,
  kompass_interfaces__action__ControlPath_FeedbackMessage__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(kompass_interfaces__action__ControlPath_FeedbackMessage);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    kompass_interfaces__action__ControlPath_FeedbackMessage * data =
      (kompass_interfaces__action__ControlPath_FeedbackMessage *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!kompass_interfaces__action__ControlPath_FeedbackMessage__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          kompass_interfaces__action__ControlPath_FeedbackMessage__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!kompass_interfaces__action__ControlPath_FeedbackMessage__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
