// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from kompass_interfaces:msg/FollowPathRequest.idl
// generated code does not contain a copyright notice
#include "kompass_interfaces/msg/detail/follow_path_request__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `path_name`
// Member `path_file_location`
// Member `robot_cmd_topic`
#include "rosidl_runtime_c/string_functions.h"

bool
kompass_interfaces__msg__FollowPathRequest__init(kompass_interfaces__msg__FollowPathRequest * msg)
{
  if (!msg) {
    return false;
  }
  // path_source
  // path_name
  if (!rosidl_runtime_c__String__init(&msg->path_name)) {
    kompass_interfaces__msg__FollowPathRequest__fini(msg);
    return false;
  }
  // path_file_location
  if (!rosidl_runtime_c__String__init(&msg->path_file_location)) {
    kompass_interfaces__msg__FollowPathRequest__fini(msg);
    return false;
  }
  // path_follower_type
  // robot_cmd_topic
  if (!rosidl_runtime_c__String__init(&msg->robot_cmd_topic)) {
    kompass_interfaces__msg__FollowPathRequest__fini(msg);
    return false;
  }
  return true;
}

void
kompass_interfaces__msg__FollowPathRequest__fini(kompass_interfaces__msg__FollowPathRequest * msg)
{
  if (!msg) {
    return;
  }
  // path_source
  // path_name
  rosidl_runtime_c__String__fini(&msg->path_name);
  // path_file_location
  rosidl_runtime_c__String__fini(&msg->path_file_location);
  // path_follower_type
  // robot_cmd_topic
  rosidl_runtime_c__String__fini(&msg->robot_cmd_topic);
}

bool
kompass_interfaces__msg__FollowPathRequest__are_equal(const kompass_interfaces__msg__FollowPathRequest * lhs, const kompass_interfaces__msg__FollowPathRequest * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // path_source
  if (lhs->path_source != rhs->path_source) {
    return false;
  }
  // path_name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->path_name), &(rhs->path_name)))
  {
    return false;
  }
  // path_file_location
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->path_file_location), &(rhs->path_file_location)))
  {
    return false;
  }
  // path_follower_type
  if (lhs->path_follower_type != rhs->path_follower_type) {
    return false;
  }
  // robot_cmd_topic
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->robot_cmd_topic), &(rhs->robot_cmd_topic)))
  {
    return false;
  }
  return true;
}

bool
kompass_interfaces__msg__FollowPathRequest__copy(
  const kompass_interfaces__msg__FollowPathRequest * input,
  kompass_interfaces__msg__FollowPathRequest * output)
{
  if (!input || !output) {
    return false;
  }
  // path_source
  output->path_source = input->path_source;
  // path_name
  if (!rosidl_runtime_c__String__copy(
      &(input->path_name), &(output->path_name)))
  {
    return false;
  }
  // path_file_location
  if (!rosidl_runtime_c__String__copy(
      &(input->path_file_location), &(output->path_file_location)))
  {
    return false;
  }
  // path_follower_type
  output->path_follower_type = input->path_follower_type;
  // robot_cmd_topic
  if (!rosidl_runtime_c__String__copy(
      &(input->robot_cmd_topic), &(output->robot_cmd_topic)))
  {
    return false;
  }
  return true;
}

kompass_interfaces__msg__FollowPathRequest *
kompass_interfaces__msg__FollowPathRequest__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__msg__FollowPathRequest * msg = (kompass_interfaces__msg__FollowPathRequest *)allocator.allocate(sizeof(kompass_interfaces__msg__FollowPathRequest), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(kompass_interfaces__msg__FollowPathRequest));
  bool success = kompass_interfaces__msg__FollowPathRequest__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
kompass_interfaces__msg__FollowPathRequest__destroy(kompass_interfaces__msg__FollowPathRequest * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    kompass_interfaces__msg__FollowPathRequest__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
kompass_interfaces__msg__FollowPathRequest__Sequence__init(kompass_interfaces__msg__FollowPathRequest__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__msg__FollowPathRequest * data = NULL;

  if (size) {
    data = (kompass_interfaces__msg__FollowPathRequest *)allocator.zero_allocate(size, sizeof(kompass_interfaces__msg__FollowPathRequest), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = kompass_interfaces__msg__FollowPathRequest__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        kompass_interfaces__msg__FollowPathRequest__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
kompass_interfaces__msg__FollowPathRequest__Sequence__fini(kompass_interfaces__msg__FollowPathRequest__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      kompass_interfaces__msg__FollowPathRequest__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

kompass_interfaces__msg__FollowPathRequest__Sequence *
kompass_interfaces__msg__FollowPathRequest__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__msg__FollowPathRequest__Sequence * array = (kompass_interfaces__msg__FollowPathRequest__Sequence *)allocator.allocate(sizeof(kompass_interfaces__msg__FollowPathRequest__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = kompass_interfaces__msg__FollowPathRequest__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
kompass_interfaces__msg__FollowPathRequest__Sequence__destroy(kompass_interfaces__msg__FollowPathRequest__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    kompass_interfaces__msg__FollowPathRequest__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
kompass_interfaces__msg__FollowPathRequest__Sequence__are_equal(const kompass_interfaces__msg__FollowPathRequest__Sequence * lhs, const kompass_interfaces__msg__FollowPathRequest__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!kompass_interfaces__msg__FollowPathRequest__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
kompass_interfaces__msg__FollowPathRequest__Sequence__copy(
  const kompass_interfaces__msg__FollowPathRequest__Sequence * input,
  kompass_interfaces__msg__FollowPathRequest__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(kompass_interfaces__msg__FollowPathRequest);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    kompass_interfaces__msg__FollowPathRequest * data =
      (kompass_interfaces__msg__FollowPathRequest *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!kompass_interfaces__msg__FollowPathRequest__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          kompass_interfaces__msg__FollowPathRequest__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!kompass_interfaces__msg__FollowPathRequest__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
