// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from kompass_interfaces:msg/FollowPathRequest.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__MSG__DETAIL__FOLLOW_PATH_REQUEST__STRUCT_H_
#define KOMPASS_INTERFACES__MSG__DETAIL__FOLLOW_PATH_REQUEST__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'FOLLOW_PATH_FROM_ROS_TOPIC'.
enum
{
  kompass_interfaces__msg__FollowPathRequest__FOLLOW_PATH_FROM_ROS_TOPIC = 0l
};

/// Constant 'FOLLOW_PATH_FROM_XML_FILE'.
enum
{
  kompass_interfaces__msg__FollowPathRequest__FOLLOW_PATH_FROM_XML_FILE = 1l
};

// Include directives for member types
// Member 'path_name'
// Member 'path_file_location'
// Member 'robot_cmd_topic'
#include "rosidl_runtime_c/string.h"

/// Struct defined in msg/FollowPathRequest in the package kompass_interfaces.
/**
  * msg request to start following a path
 */
typedef struct kompass_interfaces__msg__FollowPathRequest
{
  int32_t path_source;
  /// ROS topic name or path file xml name
  rosidl_runtime_c__String path_name;
  /// path file location
  rosidl_runtime_c__String path_file_location;
  int32_t path_follower_type;
  /// topic name for sending the control
  rosidl_runtime_c__String robot_cmd_topic;
} kompass_interfaces__msg__FollowPathRequest;

// Struct for a sequence of kompass_interfaces__msg__FollowPathRequest.
typedef struct kompass_interfaces__msg__FollowPathRequest__Sequence
{
  kompass_interfaces__msg__FollowPathRequest * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__msg__FollowPathRequest__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // KOMPASS_INTERFACES__MSG__DETAIL__FOLLOW_PATH_REQUEST__STRUCT_H_
