// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from kompass_interfaces:msg/Obstacles.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__MSG__DETAIL__OBSTACLES__BUILDER_HPP_
#define KOMPASS_INTERFACES__MSG__DETAIL__OBSTACLES__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "kompass_interfaces/msg/detail/obstacles__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace kompass_interfaces
{

namespace msg
{

namespace builder
{

class Init_Obstacles_vy
{
public:
  explicit Init_Obstacles_vy(::kompass_interfaces::msg::Obstacles & msg)
  : msg_(msg)
  {}
  ::kompass_interfaces::msg::Obstacles vy(::kompass_interfaces::msg::Obstacles::_vy_type arg)
  {
    msg_.vy = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::msg::Obstacles msg_;
};

class Init_Obstacles_vx
{
public:
  explicit Init_Obstacles_vx(::kompass_interfaces::msg::Obstacles & msg)
  : msg_(msg)
  {}
  Init_Obstacles_vy vx(::kompass_interfaces::msg::Obstacles::_vx_type arg)
  {
    msg_.vx = std::move(arg);
    return Init_Obstacles_vy(msg_);
  }

private:
  ::kompass_interfaces::msg::Obstacles msg_;
};

class Init_Obstacles_object_id
{
public:
  explicit Init_Obstacles_object_id(::kompass_interfaces::msg::Obstacles & msg)
  : msg_(msg)
  {}
  Init_Obstacles_vx object_id(::kompass_interfaces::msg::Obstacles::_object_id_type arg)
  {
    msg_.object_id = std::move(arg);
    return Init_Obstacles_vx(msg_);
  }

private:
  ::kompass_interfaces::msg::Obstacles msg_;
};

class Init_Obstacles_class_id
{
public:
  explicit Init_Obstacles_class_id(::kompass_interfaces::msg::Obstacles & msg)
  : msg_(msg)
  {}
  Init_Obstacles_object_id class_id(::kompass_interfaces::msg::Obstacles::_class_id_type arg)
  {
    msg_.class_id = std::move(arg);
    return Init_Obstacles_object_id(msg_);
  }

private:
  ::kompass_interfaces::msg::Obstacles msg_;
};

class Init_Obstacles_occupied_zone
{
public:
  explicit Init_Obstacles_occupied_zone(::kompass_interfaces::msg::Obstacles & msg)
  : msg_(msg)
  {}
  Init_Obstacles_class_id occupied_zone(::kompass_interfaces::msg::Obstacles::_occupied_zone_type arg)
  {
    msg_.occupied_zone = std::move(arg);
    return Init_Obstacles_class_id(msg_);
  }

private:
  ::kompass_interfaces::msg::Obstacles msg_;
};

class Init_Obstacles_j_grid
{
public:
  explicit Init_Obstacles_j_grid(::kompass_interfaces::msg::Obstacles & msg)
  : msg_(msg)
  {}
  Init_Obstacles_occupied_zone j_grid(::kompass_interfaces::msg::Obstacles::_j_grid_type arg)
  {
    msg_.j_grid = std::move(arg);
    return Init_Obstacles_occupied_zone(msg_);
  }

private:
  ::kompass_interfaces::msg::Obstacles msg_;
};

class Init_Obstacles_i_grid
{
public:
  explicit Init_Obstacles_i_grid(::kompass_interfaces::msg::Obstacles & msg)
  : msg_(msg)
  {}
  Init_Obstacles_j_grid i_grid(::kompass_interfaces::msg::Obstacles::_i_grid_type arg)
  {
    msg_.i_grid = std::move(arg);
    return Init_Obstacles_j_grid(msg_);
  }

private:
  ::kompass_interfaces::msg::Obstacles msg_;
};

class Init_Obstacles_y_local
{
public:
  explicit Init_Obstacles_y_local(::kompass_interfaces::msg::Obstacles & msg)
  : msg_(msg)
  {}
  Init_Obstacles_i_grid y_local(::kompass_interfaces::msg::Obstacles::_y_local_type arg)
  {
    msg_.y_local = std::move(arg);
    return Init_Obstacles_i_grid(msg_);
  }

private:
  ::kompass_interfaces::msg::Obstacles msg_;
};

class Init_Obstacles_x_local
{
public:
  explicit Init_Obstacles_x_local(::kompass_interfaces::msg::Obstacles & msg)
  : msg_(msg)
  {}
  Init_Obstacles_y_local x_local(::kompass_interfaces::msg::Obstacles::_x_local_type arg)
  {
    msg_.x_local = std::move(arg);
    return Init_Obstacles_y_local(msg_);
  }

private:
  ::kompass_interfaces::msg::Obstacles msg_;
};

class Init_Obstacles_y_global
{
public:
  explicit Init_Obstacles_y_global(::kompass_interfaces::msg::Obstacles & msg)
  : msg_(msg)
  {}
  Init_Obstacles_x_local y_global(::kompass_interfaces::msg::Obstacles::_y_global_type arg)
  {
    msg_.y_global = std::move(arg);
    return Init_Obstacles_x_local(msg_);
  }

private:
  ::kompass_interfaces::msg::Obstacles msg_;
};

class Init_Obstacles_x_global
{
public:
  explicit Init_Obstacles_x_global(::kompass_interfaces::msg::Obstacles & msg)
  : msg_(msg)
  {}
  Init_Obstacles_y_global x_global(::kompass_interfaces::msg::Obstacles::_x_global_type arg)
  {
    msg_.x_global = std::move(arg);
    return Init_Obstacles_y_global(msg_);
  }

private:
  ::kompass_interfaces::msg::Obstacles msg_;
};

class Init_Obstacles_obstacle_type
{
public:
  explicit Init_Obstacles_obstacle_type(::kompass_interfaces::msg::Obstacles & msg)
  : msg_(msg)
  {}
  Init_Obstacles_x_global obstacle_type(::kompass_interfaces::msg::Obstacles::_obstacle_type_type arg)
  {
    msg_.obstacle_type = std::move(arg);
    return Init_Obstacles_x_global(msg_);
  }

private:
  ::kompass_interfaces::msg::Obstacles msg_;
};

class Init_Obstacles_info
{
public:
  explicit Init_Obstacles_info(::kompass_interfaces::msg::Obstacles & msg)
  : msg_(msg)
  {}
  Init_Obstacles_obstacle_type info(::kompass_interfaces::msg::Obstacles::_info_type arg)
  {
    msg_.info = std::move(arg);
    return Init_Obstacles_obstacle_type(msg_);
  }

private:
  ::kompass_interfaces::msg::Obstacles msg_;
};

class Init_Obstacles_header
{
public:
  Init_Obstacles_header()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_Obstacles_info header(::kompass_interfaces::msg::Obstacles::_header_type arg)
  {
    msg_.header = std::move(arg);
    return Init_Obstacles_info(msg_);
  }

private:
  ::kompass_interfaces::msg::Obstacles msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::msg::Obstacles>()
{
  return kompass_interfaces::msg::builder::Init_Obstacles_header();
}

}  // namespace kompass_interfaces

#endif  // KOMPASS_INTERFACES__MSG__DETAIL__OBSTACLES__BUILDER_HPP_
