// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from kompass_interfaces:msg/PathTrackingErrorArray.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "kompass_interfaces/msg/detail/path_tracking_error_array__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace kompass_interfaces
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void PathTrackingErrorArray_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) kompass_interfaces::msg::PathTrackingErrorArray(_init);
}

void PathTrackingErrorArray_fini_function(void * message_memory)
{
  auto typed_message = static_cast<kompass_interfaces::msg::PathTrackingErrorArray *>(message_memory);
  typed_message->~PathTrackingErrorArray();
}

size_t size_function__PathTrackingErrorArray__orientation_errors(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<double> *>(untyped_member);
  return member->size();
}

const void * get_const_function__PathTrackingErrorArray__orientation_errors(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<double> *>(untyped_member);
  return &member[index];
}

void * get_function__PathTrackingErrorArray__orientation_errors(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<double> *>(untyped_member);
  return &member[index];
}

void fetch_function__PathTrackingErrorArray__orientation_errors(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const double *>(
    get_const_function__PathTrackingErrorArray__orientation_errors(untyped_member, index));
  auto & value = *reinterpret_cast<double *>(untyped_value);
  value = item;
}

void assign_function__PathTrackingErrorArray__orientation_errors(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<double *>(
    get_function__PathTrackingErrorArray__orientation_errors(untyped_member, index));
  const auto & value = *reinterpret_cast<const double *>(untyped_value);
  item = value;
}

void resize_function__PathTrackingErrorArray__orientation_errors(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<double> *>(untyped_member);
  member->resize(size);
}

size_t size_function__PathTrackingErrorArray__lateral_distance_errors(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<double> *>(untyped_member);
  return member->size();
}

const void * get_const_function__PathTrackingErrorArray__lateral_distance_errors(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<double> *>(untyped_member);
  return &member[index];
}

void * get_function__PathTrackingErrorArray__lateral_distance_errors(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<double> *>(untyped_member);
  return &member[index];
}

void fetch_function__PathTrackingErrorArray__lateral_distance_errors(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const double *>(
    get_const_function__PathTrackingErrorArray__lateral_distance_errors(untyped_member, index));
  auto & value = *reinterpret_cast<double *>(untyped_value);
  value = item;
}

void assign_function__PathTrackingErrorArray__lateral_distance_errors(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<double *>(
    get_function__PathTrackingErrorArray__lateral_distance_errors(untyped_member, index));
  const auto & value = *reinterpret_cast<const double *>(untyped_value);
  item = value;
}

void resize_function__PathTrackingErrorArray__lateral_distance_errors(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<double> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember PathTrackingErrorArray_message_member_array[2] = {
  {
    "orientation_errors",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_DOUBLE,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(kompass_interfaces::msg::PathTrackingErrorArray, orientation_errors),  // bytes offset in struct
    nullptr,  // default value
    size_function__PathTrackingErrorArray__orientation_errors,  // size() function pointer
    get_const_function__PathTrackingErrorArray__orientation_errors,  // get_const(index) function pointer
    get_function__PathTrackingErrorArray__orientation_errors,  // get(index) function pointer
    fetch_function__PathTrackingErrorArray__orientation_errors,  // fetch(index, &value) function pointer
    assign_function__PathTrackingErrorArray__orientation_errors,  // assign(index, value) function pointer
    resize_function__PathTrackingErrorArray__orientation_errors  // resize(index) function pointer
  },
  {
    "lateral_distance_errors",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_DOUBLE,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(kompass_interfaces::msg::PathTrackingErrorArray, lateral_distance_errors),  // bytes offset in struct
    nullptr,  // default value
    size_function__PathTrackingErrorArray__lateral_distance_errors,  // size() function pointer
    get_const_function__PathTrackingErrorArray__lateral_distance_errors,  // get_const(index) function pointer
    get_function__PathTrackingErrorArray__lateral_distance_errors,  // get(index) function pointer
    fetch_function__PathTrackingErrorArray__lateral_distance_errors,  // fetch(index, &value) function pointer
    assign_function__PathTrackingErrorArray__lateral_distance_errors,  // assign(index, value) function pointer
    resize_function__PathTrackingErrorArray__lateral_distance_errors  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers PathTrackingErrorArray_message_members = {
  "kompass_interfaces::msg",  // message namespace
  "PathTrackingErrorArray",  // message name
  2,  // number of fields
  sizeof(kompass_interfaces::msg::PathTrackingErrorArray),
  PathTrackingErrorArray_message_member_array,  // message members
  PathTrackingErrorArray_init_function,  // function to initialize message memory (memory has to be allocated)
  PathTrackingErrorArray_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t PathTrackingErrorArray_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &PathTrackingErrorArray_message_members,
  get_message_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace kompass_interfaces


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<kompass_interfaces::msg::PathTrackingErrorArray>()
{
  return &::kompass_interfaces::msg::rosidl_typesupport_introspection_cpp::PathTrackingErrorArray_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, kompass_interfaces, msg, PathTrackingErrorArray)() {
  return &::kompass_interfaces::msg::rosidl_typesupport_introspection_cpp::PathTrackingErrorArray_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
