// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from kompass_interfaces:srv/PathFromToFile.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__SRV__DETAIL__PATH_FROM_TO_FILE__STRUCT_HPP_
#define KOMPASS_INTERFACES__SRV__DETAIL__PATH_FROM_TO_FILE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__srv__PathFromToFile_Request __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__srv__PathFromToFile_Request __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct PathFromToFile_Request_
{
  using Type = PathFromToFile_Request_<ContainerAllocator>;

  explicit PathFromToFile_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->file_location = "";
      this->file_name = "";
    }
  }

  explicit PathFromToFile_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : file_location(_alloc),
    file_name(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->file_location = "";
      this->file_name = "";
    }
  }

  // field types and members
  using _file_location_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _file_location_type file_location;
  using _file_name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _file_name_type file_name;

  // setters for named parameter idiom
  Type & set__file_location(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->file_location = _arg;
    return *this;
  }
  Type & set__file_name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->file_name = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::srv::PathFromToFile_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::srv::PathFromToFile_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::srv::PathFromToFile_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::srv::PathFromToFile_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::srv::PathFromToFile_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::srv::PathFromToFile_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::srv::PathFromToFile_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::srv::PathFromToFile_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::srv::PathFromToFile_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::srv::PathFromToFile_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__srv__PathFromToFile_Request
    std::shared_ptr<kompass_interfaces::srv::PathFromToFile_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__srv__PathFromToFile_Request
    std::shared_ptr<kompass_interfaces::srv::PathFromToFile_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PathFromToFile_Request_ & other) const
  {
    if (this->file_location != other.file_location) {
      return false;
    }
    if (this->file_name != other.file_name) {
      return false;
    }
    return true;
  }
  bool operator!=(const PathFromToFile_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PathFromToFile_Request_

// alias to use template instance with default allocator
using PathFromToFile_Request =
  kompass_interfaces::srv::PathFromToFile_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace kompass_interfaces


// Include directives for member types
// Member 'global_path'
#include "nav_msgs/msg/detail/path__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__srv__PathFromToFile_Response __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__srv__PathFromToFile_Response __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct PathFromToFile_Response_
{
  using Type = PathFromToFile_Response_<ContainerAllocator>;

  explicit PathFromToFile_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : global_path(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->path_length = 0.0;
    }
  }

  explicit PathFromToFile_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : global_path(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->path_length = 0.0;
    }
  }

  // field types and members
  using _path_length_type =
    double;
  _path_length_type path_length;
  using _global_path_type =
    nav_msgs::msg::Path_<ContainerAllocator>;
  _global_path_type global_path;

  // setters for named parameter idiom
  Type & set__path_length(
    const double & _arg)
  {
    this->path_length = _arg;
    return *this;
  }
  Type & set__global_path(
    const nav_msgs::msg::Path_<ContainerAllocator> & _arg)
  {
    this->global_path = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::srv::PathFromToFile_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::srv::PathFromToFile_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::srv::PathFromToFile_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::srv::PathFromToFile_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::srv::PathFromToFile_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::srv::PathFromToFile_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::srv::PathFromToFile_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::srv::PathFromToFile_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::srv::PathFromToFile_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::srv::PathFromToFile_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__srv__PathFromToFile_Response
    std::shared_ptr<kompass_interfaces::srv::PathFromToFile_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__srv__PathFromToFile_Response
    std::shared_ptr<kompass_interfaces::srv::PathFromToFile_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PathFromToFile_Response_ & other) const
  {
    if (this->path_length != other.path_length) {
      return false;
    }
    if (this->global_path != other.global_path) {
      return false;
    }
    return true;
  }
  bool operator!=(const PathFromToFile_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PathFromToFile_Response_

// alias to use template instance with default allocator
using PathFromToFile_Response =
  kompass_interfaces::srv::PathFromToFile_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace kompass_interfaces

namespace kompass_interfaces
{

namespace srv
{

struct PathFromToFile
{
  using Request = kompass_interfaces::srv::PathFromToFile_Request;
  using Response = kompass_interfaces::srv::PathFromToFile_Response;
};

}  // namespace srv

}  // namespace kompass_interfaces

#endif  // KOMPASS_INTERFACES__SRV__DETAIL__PATH_FROM_TO_FILE__STRUCT_HPP_
