// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from kompass_interfaces:srv/PlanPath.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__SRV__DETAIL__PLAN_PATH__BUILDER_HPP_
#define KOMPASS_INTERFACES__SRV__DETAIL__PLAN_PATH__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "kompass_interfaces/srv/detail/plan_path__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace kompass_interfaces
{

namespace srv
{

namespace builder
{

class Init_PlanPath_Request_from_robot_pose
{
public:
  explicit Init_PlanPath_Request_from_robot_pose(::kompass_interfaces::srv::PlanPath_Request & msg)
  : msg_(msg)
  {}
  ::kompass_interfaces::srv::PlanPath_Request from_robot_pose(::kompass_interfaces::srv::PlanPath_Request::_from_robot_pose_type arg)
  {
    msg_.from_robot_pose = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::srv::PlanPath_Request msg_;
};

class Init_PlanPath_Request_goal
{
public:
  explicit Init_PlanPath_Request_goal(::kompass_interfaces::srv::PlanPath_Request & msg)
  : msg_(msg)
  {}
  Init_PlanPath_Request_from_robot_pose goal(::kompass_interfaces::srv::PlanPath_Request::_goal_type arg)
  {
    msg_.goal = std::move(arg);
    return Init_PlanPath_Request_from_robot_pose(msg_);
  }

private:
  ::kompass_interfaces::srv::PlanPath_Request msg_;
};

class Init_PlanPath_Request_start
{
public:
  Init_PlanPath_Request_start()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_PlanPath_Request_goal start(::kompass_interfaces::srv::PlanPath_Request::_start_type arg)
  {
    msg_.start = std::move(arg);
    return Init_PlanPath_Request_goal(msg_);
  }

private:
  ::kompass_interfaces::srv::PlanPath_Request msg_;
};

}  // namespace builder

}  // namespace srv

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::srv::PlanPath_Request>()
{
  return kompass_interfaces::srv::builder::Init_PlanPath_Request_start();
}

}  // namespace kompass_interfaces


namespace kompass_interfaces
{

namespace srv
{

namespace builder
{

class Init_PlanPath_Response_plan
{
public:
  explicit Init_PlanPath_Response_plan(::kompass_interfaces::srv::PlanPath_Response & msg)
  : msg_(msg)
  {}
  ::kompass_interfaces::srv::PlanPath_Response plan(::kompass_interfaces::srv::PlanPath_Response::_plan_type arg)
  {
    msg_.plan = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::srv::PlanPath_Response msg_;
};

class Init_PlanPath_Response_success
{
public:
  Init_PlanPath_Response_success()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_PlanPath_Response_plan success(::kompass_interfaces::srv::PlanPath_Response::_success_type arg)
  {
    msg_.success = std::move(arg);
    return Init_PlanPath_Response_plan(msg_);
  }

private:
  ::kompass_interfaces::srv::PlanPath_Response msg_;
};

}  // namespace builder

}  // namespace srv

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::srv::PlanPath_Response>()
{
  return kompass_interfaces::srv::builder::Init_PlanPath_Response_success();
}

}  // namespace kompass_interfaces

#endif  // KOMPASS_INTERFACES__SRV__DETAIL__PLAN_PATH__BUILDER_HPP_
